{Autor: DrakMrak
Sekce: Odznacky
Plugin pro nastaveni BadgeGen II - pro genrovani odznacku do statistik}
var
//-----------------------------------------
  outhtml	   	: 	AnsiString;		//vstupn html
  outhtml_flag	:	AnsiString;		//vstupn pro vlajkov
  outhtml_gray 	: 	AnsiString;		//vstupn html pro ediv
  infhtml	   	: 	AnsiString;    	//informan html
  gold		   	: 	integer;		//poet zlatch
  //-----------------------------------------
  htmlB			:	string;		//pomocn etzce - odznky
  htmlS			:	string;
  htmlG			:	string;
  htmlP			:	string;
  htmlR			:	string;
  htmlSa		:	string;
  htmlE			:	string;
  htmlD			:	string;
  htmlGray		:	string;
  //
  htmlBf		:	string;		//pomocn etzce - odznky flag
  htmlSf		:	string;
  htmlGf		:	string;
  htmlPf		:	string;
  htmlRf		:	string;
  htmlSaf		:	string;
  htmlEf		:	string;
  htmlDf		:	string;
  htmlGrayf		:	string;
  //
  htmlBelt		:	string;		//pomocn etzec - psek
  htmlFlag		:   string;		//pomocn etzec - flag
  //-----------------------------------------potadla jednotlivch rovn odznk
  BCount		:	integer;
  SCount		:	integer;
  GCount		:	integer;
  PCount		:	integer;
  RCount		:	integer;
  SaCount		:	integer;
  ECount		:	integer;
  DCount		:	integer;
  GrayCount		:	integer;
  FlagCount		:   integer;
  //Points-----------------------------------
  CachePoints	: 	integer;	//Body za cache
  HostPoints	:	integer;	//Body za vytvoen event
  MatrixPoints	:	extended;	//Body za hotov matrix (81)
  StatePoints	:	int64;		//Body za stty(USA)/zem (15/5) - USA stty
  CountryPoints :   integer;	//Body za stty(USA)/zem (15/5) - Zem
  SumCountryPoints: integer;	//Body za stty(USA)/zem (15/5)
  DailyPoints	:	extended;	//za kadch 7 dn v nejdel vln, +10 extra za 366 dn
  BusyPoints	:	integer;	//za kadch 50 ke za den ve dni kdy toho bylo nejvc (max 40)
  FPPoints		:	extended;	//za kad FP na vlastnch kech
  FDistPoints	:	integer;	//za poet rozdlnch ke v jednom dni (tam kde bylo nejvc)
  HDistPoints	:	integer;	//za rozdln typy schovanch ke
  HSizePoints	:	integer;	//za rozdln velikosti schovanch ke
  FTFPoints		:	extended;	//za FTF (max 30)
  F55Points		:	integer;	//za 5/5 kee (max 5)
  GemPoints		:	integer;	//Body za drahokam (ne u stt)
  VeteranPoints	:	integer;	//za kad rok na groundspeaku aspo s jednou ke
  CalendarPoints:	extended;	//za kalendn den (>100)
  TBPoints		:	extended;	//za kad posun/discovar TB/GC (max 25)
  PhotoPoints	:	extended;	//za kad foto nahran na GS (max 25)
  //-----------------------------------------
  bgGGeocacher 	:	int64;		//poet vech geoke
  bgTradCacher 	: 	int64;		//poet tradinch ke
  bgMultCacher	: 	int64;		//poet multi ke
  bgMystCacher 	: 	int64;		//poet mysterek
  bgVirtCacher 	: 	int64;		//poet virtulnch ke
  bgEartCacher 	: 	int64;		//poet earth ke
  bgLettCacher 	: 	int64;		//poet letterbox
  bgWherCacher	:	int64;		//poet wherigo ke
  bgMegaCacher	:	int64;		//poet megaevent
  bgEvenCacher	:	int64;
  bgCITOCacher	:	int64;
  bgTenyCacher	:	int64;
  bgBencCacher	:	int64;
  bgWebcCacher	:	int64;
  //
  bgMicrCacher	:	int64;
  bgSmalCacher	:	int64;
  bgReguCacher	:	int64;
  bgLargCacher	:	int64;
  //
  bgFiveCacher	:	int64;
  bgLazyCacher	:	int64;
  bgDifiCacher	:	int64;
  bgTerrCacher	:	int64;
  //
  bgFTFCacher	:	int64;
  bgWPedCacher	:   int64;
  //
  bgHiddCacher  :	int64;
  bgHostCacher  :	int64;
  //
  bgElevCacher	:	int64;
  bgLoweCacher	:	int64;
  //
  bgCounCacher  :	int64;
  bgTwenCacher	:	int64;
  bgConsCacher	:	int64;
  bgCaleCacher	:	int64;
  bgUndeCacher	:	int64;
  bgDistCacher	:	int64;
  bgMatrCacher	:	int64;
  bgTravCacher	:	int64;
  bgCoinCacher	:	int64;
  bgCWGCacher	:	int64;
  bgAuthorCacher:	int64;
  bgVeteCacher	:	int64;
  bgNightOwlCacher:	int64;
  bgDayNightCacher:	int64;
  //
  bgEuropaCacher:   int64;
  bgEUCacher:		int64;
  bgUniqueTypesInDay: 	int64;
  bgCZDistrict:		int64;
  bgSKDistrict:		int64;
  bgATBezirk:		int64;
  //
  bgFPCacher:		int64;
  bgPhotoCacher:	int64;
  //
  bgWaymarker:		int64;
  bgWaymarkCreator:	int64;
  bgWaymarkCategory:int64;
  //
  bgBelt:			String;
  //
  iniBFile:			TINIFile;
const
  max_bg = 55;
//------------------------------------------------------------------------------
type FTFCol = Record
	Name	:	String;
	Tag		:	String;
end;
//------------------------------------------------------------------------------  
type TLimit = Array[1..8] of integer;
//------------------------------------------------------------------------------  
//-----Sestaveni nazvu typu odznaku s limity------------------------------------
function xName(const name, units : string; const lo, hi : integer; const kladne : boolean): string;
var
  pm : String;
begin
  if kladne then pm := '' else pm := '-';
  if (hi = 0) or (hi = lo) or (hi = (lo + 1)) then
    Result := name + ' (' + pm + Trim(IntToStr(lo)) + units + ')'
  else begin
    if name = 'Diamond' then
		Result := name + ' (' + pm  + Trim(IntToStr(lo)) + units + '+)'
	else	
		Result := name + ' (' + pm  + Trim(IntToStr(lo)) + units + ' - ' + pm  +  Trim(IntToStr(hi-1)) + units + ')';
  end;
end;

//-----Ukldn dat do INI souboru----------------------------------------------
procedure SaveBadge(const Name, RealName, URL, Hint, Index, Value, Remain: String);
begin
  iniBFile := TIniFile.Create(GEOGET_SCRIPTDIR + '\BadgeGenII\Badges.ini');
  try
	iniBFile.WriteString(Name,'Name',RealName);
	iniBFile.WriteString(Name,'ImgURL',URL);
	iniBFile.WriteString(Name,'Hint',Hint);
	iniBFile.WriteString(Name,'Index',Index);
	iniBFile.WriteString(Name,'Value',Value);
	iniBFile.WriteString(Name,'Remain',Remain);  
  finally
    iniBFile.Free;
  end;  
end;

//-----Test hodnot vrac texty a potebn hodnoty-------------------------------
procedure CreateResult(const hodnota : int64; const lmt : TLimit; const name, basename, units, comment : String; const kladne, flags, show : boolean);
var
  i, j			: integer;
  hi, lo, pg 	: int64;
  percent 		: int64;
  idx, tit 		: String;
  imgname 		: String;
  unithodnota	: String;
  xhodnota		: String;
  zapor 		: boolean;
  html, ihtml 	: String;
  pm 			: String;
  GNumber		: String;
  GHeight		: String;
  //utf,ansi
  eName			: String;
  eUnits		: String;
  eComment		: String;
  
begin
  try
	  lo := 0; hi := 0; pg := 0;
	  idx := ''; tit := '';
	  html := ''; ihtml := '';
	  zapor := false;
	  //test na zporky
	  for i:= 1 to 8 do begin
		if lmt[i] = 0 then begin
		  zapor := true;
		  break;
		end;
	  end;
	  //
	  if (BGSForm_cbFormat.ItemIndex > 0) and not BGSForm_chbStator.checked then begin
		eName := AnsiToUtf(name);
		eUnits := AnsiToUtf(units);
		eComment := AnsiToUtf(comment);  
	  end  
	  else begin
		eName := name;
		eUnits := units;
		eComment := comment;
	  end;
	  
	  //
	  if kladne then pm := '' else pm := '-';
	  //----------------------------------------------------------------------------Speciln ady
	  if zapor then begin
		if basename = 'Apec' then begin		//APE kee
			case hodnota of
				0: begin idx := 'Gray'; tit := xName('None', eUnits, 0, 0, kladne); lo := 0; hi := 0; pg := 0; end; 
				1: begin idx := 'B'; tit := xName('Bronze', eUnits, 1, 1, kladne); lo := 1; hi := 1; pg := 1; end; 
				2: begin idx := 'S'; tit := xName('Silver', eUnits, 2, 2, kladne); lo := 2; hi := 2; pg := 2; end;
				3: begin idx := 'G'; tit := xName('Gold', eUnits, 3, 3, kladne); lo := 3; hi := 3; pg := 3; end;
				4: begin idx := 'P'; tit := xName('Platinum', eUnits, 4, 4, kladne); lo := 4; hi := 4; pg := 4; end;
				5: begin idx := 'R'; tit := xName('Ruby', eUnits, 5, 5, kladne); lo := 5; hi := 5; pg := 5; end;
				6: begin idx := 'Sa'; tit := xName('Sapphire', eUnits, 6, 6, kladne); lo := 6; hi := 6; pg := 6; end;
				7: begin idx := 'E'; tit := xName('Emerald', eUnits, 7, 7, kladne); lo := 7; hi := 7; pg := 7; end;
				8: begin idx := 'D'; tit := xName('Diamond', eUnits, 8, 8, kladne); lo := 8; hi := 8; pg := 8; end;
			else exit;
			end;
		end
		else begin							//Poet typ ke za jeden den
			case hodnota of
				0,1,2,3,4: begin idx := 'Gray'; tit := xName('None', eUnits, 0, 4, kladne); lo := 0; hi := 4; pg := 0; end; 
				5: begin idx := 'B'; tit := xName('Bronze', eUnits, 5, 5, kladne); lo := 5; hi := 5; pg := 1; end; 
				//2: begin idx := 'S'; tit := xName('Silver', eUnits, 2, 2, kladne); lo := 2; hi := 2; pg := 2; end;
				6: begin idx := 'G'; tit := xName('Gold', eUnits, 6, 6, kladne); lo := 6; hi := 6; pg := 3; end;
				7: begin idx := 'P'; tit := xName('Platinum', eUnits, 7, 7, kladne); lo := 7; hi := 7; pg := 4; end;
				8: begin idx := 'R'; tit := xName('Ruby', eUnits, 8, 8, kladne); lo := 8; hi := 8; pg := 5; end;
				9: begin idx := 'Sa'; tit := xName('Sapphire', eUnits, 9, 9, kladne); lo := 9; hi := 9; pg := 6; end;
				//7: begin idx := 'E'; tit := xName('Emerald', eUnits, 7, 7, kladne); lo := 7; hi := 7; pg := 7; end;
				10,11,12,13: begin idx := 'D'; tit := xName('Diamond', eUnits, 10, 10, kladne); lo := 10; hi := 10; pg := 8; end;
			else exit;
			end;
		end;
	  end
	  //---------------------------------------------------------------------------Normln ady jdouc za sebou
	  else begin
		  if (hodnota >= lmt[1]) and (hodnota < lmt[2]) then begin 
			idx := 'B'; tit := xName('Bronze', eUnits, lmt[1], lmt[2], kladne); lo := lmt[1]; hi := lmt[2]-1; pg := 1;  
		  end
		  else if (hodnota >= lmt[2]) and (hodnota < lmt[3]) then begin 
			idx := 'S'; tit := xName('Silver', eUnits, lmt[2], lmt[3], kladne); lo := lmt[2]; hi := lmt[3]-1;  pg := 2; 
		  end
		  else if (hodnota >= lmt[3]) and (hodnota < lmt[4]) then begin 
			idx := 'G'; tit := xName('Gold', eUnits, lmt[3], lmt[4], kladne); lo := lmt[3]; hi := lmt[4]-1; pg := 3; 
		  end
		  else if (hodnota >= lmt[4]) and (hodnota < lmt[5]) then begin 
			idx := 'P'; tit := xName('Platinum', eUnits, lmt[4], lmt[5], kladne); lo := lmt[4]; hi := lmt[5]-1;  pg := 4; 
		  end
		  else if (hodnota >= lmt[5]) and (hodnota < lmt[6]) then begin 
			idx := 'R'; tit := xName('Ruby', eUnits, lmt[5], lmt[6], kladne); lo := lmt[5]; hi := lmt[6]-1;  pg := 5;
		  end
		  else if (hodnota >= lmt[6]) and (hodnota < lmt[7]) then begin 
			idx := 'Sa'; tit := xName('Sapphire', eUnits, lmt[6], lmt[7], kladne); lo := lmt[6]; hi := lmt[7]-1;  pg := 6; 
		  end 
		  else if (hodnota >= lmt[7]) and (hodnota < lmt[8]) then begin 
			idx := 'E'; tit := xName('Emerald', eUnits, lmt[7], lmt[8], kladne); lo := lmt[7]; hi := lmt[8]-1;  pg := 7; 
		  end
		  else if (hodnota >= lmt[8]) then begin 
			idx := 'D'; tit := xName('Diamond', eUnits, lmt[8], -1, kladne); lo := lmt[8]; hi := hodnota;  pg := 8; 
		  end
		  else begin 
			idx := 'Gray'; tit := xName('None', '', 0, lmt[1], kladne); lo := 0; hi := lmt[1]-1; pg := 0; 
		  end;
	  end;
	  //
	  if comment <> '' then tit := tit + ' ' + eComment;
	  //
	  try
		if hodnota = 0 then
			percent := 0
		else if hi = lo then
			percent := 100
		else
			percent := Round(((hodnota - lo) * 100.00)/(hi - lo));
	  except
		percent := 0;
	  end;
	  //
	  if flags then
		imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + 'f/' + basename + idx
	  else
		imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + idx;
	  //	
	  unithodnota := pm + Trim(IntToStr(hodnota)) + eUnits;
	  xhodnota := pm + Trim(IntToStr(hodnota));
	  //
	  if show then begin
		if (BGSForm_chbGraph.checked) then begin
		  if (idx <> 'D') then begin			//Ostatn
			GNumber := '';
			GHeight := '10';
			if (BGSForm_chbNumber.checked) then begin
			  if zapor then			//Speciln ady - APE a Unique
				GNumber := '&chm=t' + '1' + eUnits + ',' + TableScaleText + ',1,,11,,e::-1'
			  else begin			//klasika
				GNumber := '&chm=t' + Trim(IntToStr(lmt[pg+1] - hodnota)) + eUnits + ',' + TableScaleText + ',1,,11,,e::-1';
			  end;
			  GHeight := '12'
			end;
			//
			html := '<div class="BGII_Badge" style="display: inline-block; margin: 0 auto; zoom:1; *display: inline;">' + CRLF + '<img src="' + imgname;
			html := html + '.png" width="' + Trim(BGSForm_edBGSize.Text) + '" title="' + eName + ' - #' + unithodnota + ' / ' + tit;
			html := html + '" /><br />' + CRLF;
			html := html + '<img src="http://chart.apis.google.com/chart?chbh=a,0&chs=' + Trim(BGSForm_edBGSize.Text) + 'x' + GHeight + '&cht=bhs&chco=' + TableScaleMaxBkg + ',' + TableScaleMinBkg + '&chds=0,100&chd=t:';
			html := html + Trim(IntToStr(percent)) + '|100&chdlp=l' + GNumber + '" />' + CRLF;
			html := html + '</div>' + CRLF;
		  end
		  else begin							//Diamant
			html := '<div class="BGII_Badge" style="display: inline-block; margin: 0 auto; zoom:1; *display: inline;">' + CRLF + '<img src="' + imgname;
			html := html + '.png" width="' + Trim(BGSForm_edBGSize.Text) + '" title="' + eName + ' - #' + unithodnota + ' / ' + tit;
			html := html + '" /><br />' + CRLF;
			html := html + '<div class="BGII_Space" style="font-size:10px; width: ' + Trim(BGSForm_edBGSize.Text) + ';">&nbsp;&nbsp;&nbsp;</div>' + CRLF;
			html := html + '</div>' + CRLF;
		  end;
		end
		else
		  html := '<img src="' + imgname + '.png" width="' + BGSForm_edBGSize.Text + '" title="' + eName + ' - #' + unithodnota + ' / ' + tit + '" /> ';
	  end;	
	  if (flags and BGSForm_chbSFlags.checked) then begin
		case idx of
			'B': begin htmlBf := htmlBf + html; end;
			'S': begin htmlSf := htmlSf + html; end;
			'G': begin htmlGf := htmlGf + html; end;
			'P': begin htmlPf := htmlPf + html; end;
			'R': begin htmlRf := htmlRf + html; end;
			'Sa': begin htmlSaf := htmlSaf + html; end;
			'E': begin htmlEf := htmlEf + html; end;
			'D': begin htmlDf := htmlDf + html; end;
			'Gray': begin htmlGray := htmlGray + html; if not flags then Inc(GrayCount); end;
		end;
	  end
	  else begin
		case idx of
			'B': begin 
				htmlB := htmlB + html; 
				Inc(BCount); 
			end;
			'S': begin 
				htmlS := htmlS + html; 
				Inc(SCount); 
			end;
			'G': begin 
				htmlG := htmlG + html; 
				Inc(GCount); 
			end;
			'P': begin 
				htmlP := htmlP + html; 
				Inc(PCount); 
			end;
			'R': begin 
				htmlR := htmlR + html; 
				Inc(RCount); 
				if not flags then Inc(GemPoints); 
				end;
			'Sa': begin 
				htmlSa := htmlSa + html; 
				Inc(SaCount); 
				if not flags then Inc(GemPoints); 
			end;
			'E': begin 
				htmlE := htmlE + html; 
				Inc(ECount); 
				if not flags then Inc(GemPoints); 
			end;
			'D': begin 
				htmlD := htmlD + html;			
				Inc(DCount);		
				if not flags then Inc(GemPoints);
			end;
			'Gray': begin 
				htmlGray := htmlGray + html; 
				if not flags then Inc(GrayCount); 
			end;
		end;
	  end;
	  //
	  if ((pg + 1) > 8) then	//Diamant
		SaveBadge(basename, eName, imgname + '.png', eName + ' - #' + unithodnota + ' / ' + tit, idx, unithodnota, '+' + Trim(IntToStr(hodnota - lmt[pg])) + eUnits)
	  else						//Ostatn
		SaveBadge(basename, eName, imgname + '.png', eName + ' - #' + unithodnota + ' / ' + tit, idx, unithodnota, Trim(IntToStr(lmt[pg+1] - hodnota)) + eUnits);
	  //
	  if show then begin  
		ihtml := ihtml + '<div class="BGII_BadgeDetail" style="display:block; margin: 0 auto;">' + CRLF;
		ihtml := ihtml + '<table border="1" style="background-color:#'+ TableEmptyBkg +'; text-align:center;" bordercolor="#'+ TableEmptyBkgOdd +'" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
		ihtml := ihtml + '<tr><td rowspan="3" width="106px"><img src="' + imgname + '.png" title="' + eName + ' - #' + unithodnota + ' / ' + tit + '" /></td>';
		//ihtml := ihtml + '<td colspan="10"><b>' + eName + ' (' + IntToStr(percent) + '%)</b></td></tr><tr>';
		if eUnits <> '' then
			ihtml := ihtml + '<td colspan="10"><b>' + eName + '</b>' + ' (' + eUnits + ')</td></tr>' + CRLF + '<tr>'
		else
			ihtml := ihtml + '<td colspan="10"><b>' + eName + '</b></td></tr>' + CRLF + '<tr>';
		ihtml := ihtml + '<td width="10%">B</td><td width="10%">S</td><td width="10%">G</td><td width="10%">P</td><td width="10%">R</td><td width="10%">Sa</td><td width="10%">E</td><td width="10%">D</td><td width="10%">&#931;</td><td width="10%">+</td></tr>' + CRLF + '<tr>';
		for i := 1 to 8 do begin
			if zapor then begin		//specil
				if lmt[i] = 0 then
					ihtml := ihtml + '<td>-</td>'
				else if i <= pg then
					ihtml := ihtml + '<td style="background-color:#' + TableScaleMinBkg + ';">' + pm + Trim(IntToStr(lmt[i])) + {eUnits +} '</td>'
				else begin
					j := 0;
					if (pg < 8) then begin
						for j := (pg+1) to 8 do begin
							if lmt[j] <> 0 then break;
						end;
					end;
					if (i = j) then begin
						ihtml := ihtml + '<td style="background-color:#' + TableScaleMaxBkg + ';">';
						ihtml := ihtml + pm + Trim(IntToStr(lmt[i])) + {eUnits +} '</td>';
					end
					else
						ihtml := ihtml + '<td>' + pm + Trim(IntToStr(lmt[i])) + {eUnits +} '</td>';
				end;					
			end
			else begin				//norml
				if i <= pg then 
					ihtml := ihtml + '<td style="background-color:#' + TableScaleMinBkg + '">' + pm + Trim(IntToStr(lmt[i])) + {eUnits +} '</td>'
				else if i = (pg + 1) then
					ihtml := ihtml + '<td style="background-color:#' + TableScaleMaxBkg + ';">' + pm + Trim(IntToStr(lmt[i])) + {eUnits +} '</td>'
				else
					ihtml := ihtml + '<td>' + pm + Trim(IntToStr(lmt[i])) + {eUnits +} '</td>' ;
			end;
		end;
		//
		ihtml := ihtml + '<td style="background-color:#' + TableScaleMinBkg + '; width:60px;">' + xhodnota + '</td>';
		if (pg = 8) or (pg >= lmt[8]) then	//Diamant
			ihtml := ihtml + '<td style="background-color:#' + TableScaleMaxBkg + '; width:60px;">---</td>'
		else begin							//Ostatn
			if not zapor then begin		//norml
				ihtml := ihtml + '<td style="background-color:#' + TableScaleMaxBkg + '; width:60px;">' + pm + Trim(IntToStr(lmt[pg+1] - hodnota)) + {eUnits +} '</td>';
			end
			else						//specil
				ihtml := ihtml + '<td style="background-color:#' + TableScaleMaxBkg + '; width:60px;">' + pm + ' 1 ' + {eUnits +} '</td>'
		end;
		//
		ihtml := ihtml + '</tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;
		infhtml := infhtml + ihtml;
	  end;
  except
      ShowMessage(ExceptionToString(ExceptionType, ExceptionParam) + CRLF + CRLF + name + ' (' + IntToStr(hodnota) + ')');
  end;
end;

procedure kouskovac(var pole : TLimit; const text,oddelovac : String);
var
 i : integer;
begin
  for i := 1 to 8 do begin
	pole[i] := StrToInt(Fetch(text,oddelovac));
  end;
end;

function iso2toiso3(iso2:String):String;
var
  alliso2, alliso3: String;
  i :integer;
begin
  if iso2 = 'UK' then iso2 := 'GB';		//Uprava pro anglii
  alliso2 := 'AF,AL,DZ,AS,AD,AO,AI,AQ,AG,AR,AM,AW,AU,AT,AZ,BS,BH,BD,BB,BY,BE,BZ,BJ,BM,BT,BO,BA,BW,BV,BR,IO,BN,BG,BF,BI,KH,CM,CA,CV,KY,CF,TD,CL,CN,CX,CC,CO,KM,CG,CD,CK,CR,CI,HR,CU,CY,CZ,DK,DJ,DM,DO,EC,EG,SV,GQ,ER,EE,ET,FK,FO,FJ,FI,FR,GF,PF,TF,GA,GM,GE,DE,GH,GI,GR,GL,GD,GP,GU,GT,GN,GW,GY,HT,HM,VA,HN,HK,HU,IS,IN,ID,IR,IQ,IE,IL,IT,JM,JP,JO,KZ,KE,KI,KP,KR,KW,KG,LA,LV,LB,LS,LR,LY,LI,LT,LU,MO,MK,MG,MW,MY,MV,ML,MT,MH,MQ,MR,MU,YT,MX,FM,MD,MC,MN,MS,MA,MZ,MM,NA,NR,NP,NL,AN,NC,NZ,NI,NE,NG,NU,NF,MP,NO,OM,PK,PW,PS,PA,PG,PY,PE,PH,PN,PL,PT,PR,QA,RE,RO,RU,RW,SH,KN,LC,PM,VC,WS,SM,ST,SA,SN,CS,SC,SL,SG,SK,SI,SB,SO,ZA,GS,ES,LK,SD,SR,SJ,SZ,SE,CH,SY,TW,TJ,TZ,TH,TL,TG,TK,TO,TT,TN,TR,TM,TC,TV,UG,UA,AE,GB,US,UM,UY,UZ,VU,VE,VN,VG,VI,WF,EH,YE,ZM,ZW,AX,JE,ME,MF,RS';
  alliso3 := 'AFG,ALB,DZA,ASM,AND,AGO,AIA,---,ATG,ARG,ARM,ABW,AUS,AUT,AZE,BHS,BHR,BGD,BRB,BLR,BEL,BLZ,BEN,BMU,BTN,BOL,BIH,BWA,---,BRA,---,BRN,BGR,BFA,BDI,KHM,CMR,CAN,CPV,CYM,CAF,TCD,CHL,CHN,---,---,COL,COM,COG,COD,COK,CRI,CIV,HRV,CUB,CYP,CZE,DNK,DJI,DMA,DOM,ECU,EGY,SLV,GNQ,ERI,EST,ETH,FLK,FRO,FJI,FIN,FRA,GUF,PYF,---,GAB,GMB,GEO,DEU,GHA,GIB,GRC,GRL,GRD,GLP,GUM,GTM,GIN,GNB,GUY,HTI,---,VAT,HND,HKG,HUN,ISL,IND,IDN,IRN,IRQ,IRL,ISR,ITA,JAM,JPN,JOR,KAZ,KEN,KIR,PRK,KOR,KWT,KGZ,LAO,LVA,LBN,LSO,LBR,LBY,LIE,LTU,LUX,MAC,MKD,MDG,MWI,MYS,MDV,MLI,MLT,MHL,MTQ,MRT,MUS,---,MEX,FSM,MDA,MCO,MNG,MSR,MAR,MOZ,MMR,NAM,NRU,NPL,NLD,ANT,NCL,NZL,NIC,NER,NGA,NIU,NFK,MNP,NOR,OMN,PAK,PLW,---,PAN,PNG,PRY,PER,PHL,PCN,POL,PRT,PRI,QAT,REU,ROU,RUS,RWA,SHN,KNA,LCA,SPM,VCT,WSM,SMR,STP,SAU,SEN,---,SYC,SLE,SGP,SVK,SVN,SLB,SOM,ZAF,---,ESP,LKA,SDN,SUR,SJM,SWZ,SWE,CHE,SYR,TWN,TJK,TZA,THA,---,TGO,TKL,TON,TTO,TUN,TUR,TKM,TCA,TUV,UGA,UKR,ARE,GBR,USA,---,URY,UZB,VUT,VEN,VNM,VGB,VIR,WLF,ESH,YEM,ZMB,ZWE,ALA,JEY,MNE,MAF,SRB';
  i := Pos(iso2,alliso2) div 3;
  result := Copy(alliso3,i*4+1,3);
end;

function USAstates():Int64;
var
  sql:String;
begin
  //SQL
  sql := 'select count(cnt) from';
  sql := sql + ' (select count(gc.id) cnt';
  sql := sql + ' from geocache gc';
  sql := sql + ' where gc.dtfound > 0';
  sql := sql + '   and gc.state <> ''''';  
  sql := sql + '   and gc.country = ''United States''';
  sql := sql + ' group by gc.state)';
  //hodnota
  result := GEOGET_DB.GetTableValue(sql);
end;

//******************************************************************************
//								B A D G E S
//******************************************************************************
//
//-----Geocacher----------------------------------------------------------------
//AllCaches - poet ke
//------------------------------------------------------------------------------
procedure BG_Geocacher(const AllCaches: integer);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '500,1000,2000,3000,5000,8000,12000,18000,';
  kouskovac(lmt,limity,',');
  name := _('The Geocacher');
  imgbasename := 'GGeoc';
  units := '';
  comment := '';
  //SQL
  //---
  //hodnota
  bgGGeocacher := AllCaches;
  //podminky a vystupy
  CreateResult(bgGGeocacher, lmt, name, imgbasename, units, comment, True, False, True);
  Inc(cnt);
  CachePoints := AllCaches div 100;
  GeoBusyProgress(cnt, max_bg);
end;
//-----Traditional Cacher-------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_TraditionalCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '400,1000,2000,3000,5000,7000,10000,15000,';
  kouskovac(lmt,limity,',');
  name := _('The Traditional Cacher');
  imgbasename := 'Trad';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Traditional Cache''';
  //hodnota
  bgTradCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgTradCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgTraditional.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;
//-----Multi Cacher-------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MultiCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '50,100,200,300,500,800,1200,1800,';
  kouskovac(lmt,limity,',');
  name := _('The Multi Cacher');
  imgbasename := 'Mult';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Multi-cache''';
  //hodnota
  bgMultCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgMultCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgMulti.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Mysterious Cacher--------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MysteriousCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '50,100,200,300,500,800,1200,1800,';
  kouskovac(lmt,limity,',');
  name := _('The Mysterious Cacher');
  imgbasename := 'Myst';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Unknown Cache''';
  //hodnota
  bgMystCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgMystCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgMystery.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Virtual Cacher-----------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_VirtualCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '5,10,20,30,50,80,120,180,';
  kouskovac(lmt,limity,',');
  name := _('The Virtual Cacher');
  imgbasename := 'Virt';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Virtual Cache''';
  //hodnota
  bgVirtCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgVirtCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgVirtual.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Earth Cacher-----------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_EarthCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '5,10,20,30,50,80,120,180,';
  kouskovac(lmt,limity,',');
  name := _('The Earth Cacher');
  imgbasename := 'Eart';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Earthcache''';
  //hodnota
  bgEartCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgEartCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgEarth.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;
//-----Letterboxer--------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_LetterboxCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '5,6,7,8,10,15,25,50,';
  kouskovac(lmt,limity,',');
  name := _('The Letterboxer');
  imgbasename := 'Lett';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Letterbox Hybrid''';
  //hodnota
  bgLettCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgLettCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgLetter.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;
//-----Wherigo cacher-----------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_WherigoCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '2,3,5,10,15,25,40,60,';
  kouskovac(lmt,limity,',');
  name := _('The Wherigo Cacher');
  imgbasename := 'Wher';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Wherigo Cache''';
  //hodnota
  bgWherCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgWherCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgWherigo.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;
//-----Mega social cacher-------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MegaEvCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,2,3,4,5,6,7,8,';
  kouskovac(lmt,limity,',');  
  name := _('The Mega Social Cacher');
  imgbasename := 'Mega';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Mega-Event Cache''';
  //hodnota
  bgMegaCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgMegaCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgMEvent.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;
//-----Social cacher------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_EventCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '5,10,20,30,50,80,120,180,';
  kouskovac(lmt,limity,',');    
  name := _('The Social Cacher');
  imgbasename := 'Even';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Event Cache''';
  //hodnota
  bgEvenCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgEvenCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgEvent.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Environmental cacher-----------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_CITOCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '2,3,4,5,6,8,10,12,';
  kouskovac(lmt,limity,',');  
  name := _('The Environmental Cacher');
  imgbasename := 'CITO';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Cache In Trash Out Event''';
  //hodnota
  bgCITOCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgCITOCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgCITO.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Lost and Found event-----------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_LaFCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,2,3,4,5,6,7,8,';
  kouskovac(lmt,limity,',');  
  name := _('The Lost & Found Cacher');
  imgbasename := 'Teny';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Lost and Found Event Cache''';
  //hodnota
  bgTenyCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgTenyCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgLostFound.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Lost and Found event-----------------------------------------------------
//Benchmarks - poet znaek
//------------------------------------------------------------------------------
procedure BG_Benchmarker(Benchmarks:int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  //sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '15,20,30,50,80,120,180,250,';
  kouskovac(lmt,limity,',');    
  name := _('The Benchmarker');
  imgbasename := 'Benc';
  units := '';
  comment := '';
  //SQL
  //---
  //hodnota
  bgBencCacher := Benchmarks;
  //podminky a vystupy
  CreateResult(bgBencCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgBenchmark.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;
//-----Webcam-------------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_WebCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '2,3,5,8,12,18,25,40,';
  kouskovac(lmt,limity,',');      
  name := _('The Photogenic Cacher');
  imgbasename := 'Webc';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Webcam Cache''';
  //hodnota
  bgWebcCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgWebcCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgWebcam.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Ape Cache----------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_ApeCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,0,0,2,0,0,0,3,';
  kouskovac(lmt,limity,',');      
  name := _('The APE Cacher');
  imgbasename := 'Apec';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachetype = ''Project APE Cache''';
  //hodnota
  bgWebcCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgWebcCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgApe.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Micro Cacher-------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MicroCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '200,300,500,800,1200,1800,3000,4500,';
  kouskovac(lmt,limity,',');      
  name := _('The Micro Cacher');
  imgbasename := 'Micr';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachesize = ''Micro''';
  //hodnota
  bgMicrCacher := GEOGET_DB.GetTableValue(sql);
  if bgMicrCacher > lmt[2] then Inc(gold);
  //podminky a vystupy
  CreateResult(bgMicrCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgMicro.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Small Cacher-------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_SmallCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '150,200,300,500,800,1200,1800,3000,';
  kouskovac(lmt,limity,',');      
  name := _('The Small Cacher');
  imgbasename := 'Smal';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachesize = ''Small''';
  //hodnota
  bgSmalCacher := GEOGET_DB.GetTableValue(sql);
  if bgSmalCacher > lmt[2] then Inc(gold);
  //podminky a vystupy
  CreateResult(bgSmalCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgSmall.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Regular Cacher-----------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_RegularCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '100,150,200,300,500,800,1200,2000,';
  kouskovac(lmt,limity,',');      
  name := _('The Regular Cacher');
  imgbasename := 'Regu';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachesize = ''Regular''';
  //hodnota
  bgReguCacher := GEOGET_DB.GetTableValue(sql);
  if bgReguCacher > lmt[2] then Inc(gold);
  //podminky a vystupy
  CreateResult(bgReguCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgRegular.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Large Cacher-------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_LargeCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '3,10,20,30,50,80,120,180,';
  kouskovac(lmt,limity,',');      
  name := _('The Large Cacher');
  imgbasename := 'Larg';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.cachesize = ''Large''';
  //hodnota
  bgLargCacher := GEOGET_DB.GetTableValue(sql);
  if bgLargCacher > lmt[2] then Inc(gold);
  //podminky a vystupy
  CreateResult(bgLargCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgLarge.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----5/5 Cacher---------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_AdventurousCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,2,3,5,8,12,18,30,';
  kouskovac(lmt,limity,',');      
  name := _('The Adventurous Cacher');
  imgbasename := 'Five';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.difficulty = 5 and gc.terrain = 5';
  //hodnota
  bgFiveCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgFiveCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgExtreme.checked);
  Inc(cnt);
  F55Points := bgFiveCacher;
  if F55Points > 5 then F55Points := 5;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----1/1 Cacher---------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_LazyCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '15,20,30,50,80,120,180,300,';
  kouskovac(lmt,limity,',');      
  name := _('The Lazy Cacher');
  imgbasename := 'Lazy';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.difficulty = 1 and gc.terrain = 1';
  //hodnota
  bgLazyCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgLazyCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgLazy.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Brainiac Cacher----------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_BrainiacCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '2,4,6,9,15,25,40,60,';
  kouskovac(lmt,limity,',');      
  name := _('The Brainiac');
  imgbasename := 'Difi';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.difficulty = 5';
  //hodnota
  bgDifiCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgDifiCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgDiff.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Rugged Cacher------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_RuggedCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '5,10,20,30,50,80,120,180,';
  kouskovac(lmt,limity,',');      
  name := _('The Rugged Cacher');
  imgbasename := 'Terr';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.terrain = 5';
  //hodnota
  bgTerrCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgTerrCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgTerr.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----FTF Cacher---------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_FTFCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
  FTFTag, pom, ftfstr : String;
begin
  //start
  ftfstr := FTF_COLUMNS;
  //
  if ftfstr <> '' then begin
	pom := Fetch(ftfstr,',');
	FTFTag := Fetch(pom,'|');
	FTFTag := pom;				//Tag FTF 
  end
  else FTFTag := 'FTF';			//Defaultn FTF
  //inicializace
  limity := '15,20,30,50,80,120,180,300,';
  kouskovac(lmt,limity,',');      
  name := _('The FTF Addict');
  imgbasename := 'FTF';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc';
  sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''' + FTFTag + '''))';
  sql := sql + ' where gc.dtfound > 0 and gt.ptrvalue in (select key from geotagvalue where value LIKE ''%FTF%'')';
  //hodnota
  bgFTFCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgFTFCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgFTF.checked);
  Inc(cnt);
  FTFPoints := bgFTFCacher * 0.5;
  if FTFPoints > 30 then FTFPoints := 30;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----The Cacher on Winners Pedestal-------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_WPedCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
  xTF : array of FTFCol;
  pom, ftfstr : String;
  i	: integer;
begin
  //start
  SetLength(xTF,3);
  ftfstr := FTF_COLUMNS;
  if ftfstr <> '' then begin		//Vytah nzvy TAG k pslunm hodnotm
	//1
	pom := Fetch(ftfstr,',');
	xTF[0].Name := Fetch(pom,'|');
	xTF[0].Tag  := pom;
	//2
	pom := Fetch(ftfstr,',');
	xTF[1].Name := Fetch(pom,'|');
	xTF[1].Tag  := pom;
	//3
	pom := ftfstr
	xTF[2].Name := Fetch(pom,'|');
	xTF[2].Tag  := pom;
  end
  else begin						//Defaultn je TAG = 'FTF'
	xTF[0].Name := 'FTF';
	xTF[0].Tag := 'FTF';
	xTF[1].Name := 'STF';
	xTF[1].Tag := 'FTF';
	xTF[2].Name := 'TTF';
	xTF[2].Tag := 'FTF';
  end;
  //
  //inicializace
  limity := '40,60,100,150,250,400,600,1000,';
  kouskovac(lmt,limity,',');      
  name := _('The Cacher on Winners Pedestal');
  imgbasename := 'WPed';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc';
  for i:= 0 to 2 do begin
	sql := sql + ' left join geotag gt' + IntToStr(i + 1) + ' on (gc.id = gt' + IntToStr(i + 1) + '.id and gt' + IntToStr(i + 1) + '.ptrkat = (select key from geotagcategory where value = ''' + xTF[i].Tag + '''))';
  end;
  sql := sql + ' where gc.dtfound > 0'; // gt.ptrvalue in (select key from geotagvalue where value LIKE ''%FTF%'' or value LIKE ''%STF%'' or value LIKE ''%TTF%'')';
  sql := sql + ' and (gt1.ptrvalue in (select key from geotagvalue where value LIKE ''%' + xTF[0].Name + '%'')';
  sql := sql + ' or gt2.ptrvalue in (select key from geotagvalue where value LIKE ''%' + xTF[1].Name + '%'')';
  sql := sql + ' or gt3.ptrvalue in (select key from geotagvalue where value LIKE ''%' + xTF[2].Name + '%''))';
 
  //ShowHTMLMessage('test',sql);
  //hodnota
  bgWPedCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgWPedCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgWPed.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
  SetLength(xTF,0);  
end;
//-----Hide Cache---------------------------------------------------------------
//MyCaches - poet zaloench krabiek (bez event)
//------------------------------------------------------------------------------
procedure BG_MyCaches(MyCaches:int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  //sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '10,15,20,30,50,80,120,200,';
  kouskovac(lmt,limity,',');    
  name := _('The Cache Owner');
  imgbasename := 'Hidd';
  units := '';
  comment := '';
  //SQL
  //---
  //hodnota
  bgHiddCacher := MyCaches;
  //podminky a vystupy
  CreateResult(bgHiddCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgHidden.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Hide Event---------------------------------------------------------------
//MyEvents - poet zaloench event
//------------------------------------------------------------------------------
procedure BG_MyEvents(MyEvents:int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  //sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,2,3,5,8,12,18,30,';
  kouskovac(lmt,limity,',');    
  name := _('The Event Host');
  imgbasename := 'Host';
  units := '';
  comment := '';
  //SQL
  //---
  //hodnota
  bgHostCacher := MyEvents;
  //podminky a vystupy
  CreateResult(bgHostCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgHost.checked);
  Inc(cnt);
  HostPoints := MyEvents * 2;
  if HostPoints > 30 then HostPoints := 30;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Max Elevation------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MaxElevCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '500,1000,1500,2000,2500,3000,3500,4500,';
  kouskovac(lmt,limity,',');      
  name := _('Head-In-The-Clouds Award');
  imgbasename := 'Elev';
  units := 'm';
  //SQL
  sql := 'select ifnull(max(CAST(gv.value AS INTEGER)),0) from geocache gc';
  sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''Elevation''))';
  sql := sql + ' inner join geotagvalue gv on(gt.ptrvalue = gv.[key])'
  sql := sql + ' where gc.dtfound > 0 and CAST(gv.value AS INTEGER) > 0';
  //hodnota
  bgElevCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgElevCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgElevation.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Min Elevation------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MinElevCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,50,100,150,200,250,300,400,';
  kouskovac(lmt,limity,',');      
  name := _('The Head-In-The-Ground Award');
  imgbasename := 'Lowe';
  units := 'm';
  //SQL
  sql := 'select ifnull(min(CAST(gv.value AS INTEGER)),0) from geocache gc';
  sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''Elevation''))';
  sql := sql + ' inner join geotagvalue gv on(gt.ptrvalue = gv.[key])'
  sql := sql + ' where gc.dtfound > 0 and CAST(gv.value AS INTEGER) < 0';
  //hodnota
  bgLoweCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(Round(Abs(bgLoweCacher)), lmt, name, imgbasename, units, comment, False, False, BGSForm_chbgLowe.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Traveling Cacher---------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_TravelingCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  if BGSForm_chbUS.checked then
	limity := '2,3,5,8,12,18,25,35,'		//US
  else
    limity := '4,6,9,14,20,28,40,50,';		//Evropa
  kouskovac(lmt,limity,',');      
  name := _('The Travelling Cacher');
  imgbasename := 'Coun';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(*) from (select count(*) from geocache gc where gc.dtfound>0 group by gc.country)';
  //hodnota
  bgCounCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgCounCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgTraveling.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Busy Cacher--------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_BusyCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '20,30,50,80,120,180,270,400,';
  kouskovac(lmt,limity,',');      
  name := _('The Busy Cacher');
  imgbasename := 'Twen';
  units := '';
  comment := '';
  //SQL
  sql := 'select max(cnt) from (select count(gc.dtfound) cnt from geocache gc where gc.dtfound>0 group by gc.dtfound)';
  //hodnota
  bgTwenCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgTwenCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgBusy.checked);
  Inc(cnt);
  BusyPoints := (bgTwenCacher div 50) * 10
  if BusyPoints > 40 then BusyPoints := 40;
  GeoBusyProgress(cnt, max_bg);
end;
//-----Daily Cacher-------------------------------------------------------------
//Daily - poet souvislch dn lovu
//------------------------------------------------------------------------------
procedure BG_DailyCacher(Daily : integer; tod, tdo: TDateTime);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '7,14,30,60,122,183,274,365,';
  kouskovac(lmt,limity,',');      
  name := _('The Daily Cacher');
  imgbasename := 'Cons';
  units := '';
  comment := '[' + FormatDateTime('ddddd', tod) + ' - ' + FormatDateTime('ddddd', tdo) + ']';
  //SQL
  //hodnota
  bgConsCacher := Daily;
  //podminky a vystupy
  CreateResult(bgConsCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgDaily.checked);
  Inc(cnt);
  DailyPoints := (Daily div 7) * 0.5;
  if Daily >= 366 then DailyPoints := DailyPoints + 10;
  GeoBusyProgress(cnt, max_bg);
end;
//-----Calendar Cacher----------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_CalendarCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '100,150,200,250,300,350,365,366,';
  kouskovac(lmt,limity,',');      
  name := _('The Calendar Cacher');
  imgbasename := 'Cale';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(*) from (select substr(CAST(gc.dtfound AS text),5) from geocache gc where gc.dtfound>0 group by substr(CAST(gc.dtfound AS text),5))';
  //hodnota
  bgCaleCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgCaleCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgCalendar.checked);
  Inc(cnt);
  if bgCaleCacher > 100 then begin
	CalendarPoints := bgCaleCacher * 0.08;
  end;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Scuba Cacher-------------------------------------------------------------
//Scuba - poet potpn pro ke
//------------------------------------------------------------------------------
procedure BG_ScubaCacher(Scuba : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1,2,3,4,5,6,7,10,';
  kouskovac(lmt,limity,',');      
  name := _('The Scuba-Cacher');
  imgbasename := 'Unde';
  units := '';
  comment := '';
  //SQL
  //hodnota
  bgUndeCacher := Scuba;
  //podminky a vystupy
  CreateResult(bgUndeCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgScuba.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----LongDistance Cacher------------------------------------------------------
//LongDistance - nejvt vzdlenost za den
//------------------------------------------------------------------------------
procedure BG_LongDistCacher(LongDistance : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '1000,1200,1500,2000,2900,4200,6400,10000,';
  kouskovac(lmt,limity,',');      
  name := _('The Long-Distance Cacher');
  imgbasename := 'Dist';
  units := 'km';
  //SQL
  //hodnota
  bgDistCacher := LongDistance;
  //podminky a vystupy
  CreateResult(bgDistCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgLongDistance.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Matrix Cacher------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_MatrixCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '20,25,30,40,50,60,80,81,';
  kouskovac(lmt,limity,',');      
  name := _('The Matrix Cacher');
  imgbasename := 'Matr';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(distinct trim(CAST(CAST(gc.terrain as money) as text))||''-''||trim(CAST(CAST(gc.difficulty as money) as text))) cnt';
  sql := sql + ' from geocache gc';
  sql := sql + ' where gc.dtfound > 0';
  sql := sql + ' and (CAST(gc.terrain as money) > 0 and CAST(gc.terrain as money) < 5.1)';
  sql := sql + ' and (CAST(gc.difficulty as money) > 0 and CAST(gc.difficulty as money) < 5.1);';  
  //hodnota
  bgMatrCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgMatrCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgMatrix.checked);
  Inc(cnt);
  if bgMatrCacher > 40 then MatrixPoints := (bgMatrCacher - 40) * 0.5;
  if bgMatrCacher = 81 then MatrixPoints := MatrixPoints + 10;
  GeoBusyProgress(cnt, max_bg);
end;
//-----Travel Bug---------------------------------------------------------------
//TB - Travel bugy
//------------------------------------------------------------------------------
procedure BG_TB(TB : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '50,100,200,300,500,800,1200,1800,';
  kouskovac(lmt,limity,',');      
  name := _('The Travel Bug');
  imgbasename := 'Trav';
  units := '';
  comment := '';
  //SQL
  //hodnota
  bgTravCacher := TB;
  //podminky a vystupy
  CreateResult(bgTravCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgTB.checked);
  Inc(cnt);
  TBPoints := TBPoints + (bgTravCacher * 0.05);
  if TBPoints > 25 then TBPoints := 25;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Coin Collector-----------------------------------------------------------
//Coin - Mince
//------------------------------------------------------------------------------
procedure BG_Coin(Coin : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '50,100,200,300,500,800,1200,1800,';
  kouskovac(lmt,limity,',');      
  name := _('The Coin Collector');
  imgbasename := 'Coin';
  units := '';
  comment := '';
  //SQL
  //hodnota
  bgCoinCacher := Coin;
  //podminky a vystupy
  CreateResult(bgCoinCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgCoin.checked);
  Inc(cnt);
  TBPoints := TBPoints + (bgCoinCacher * 0.05);
  if TBPoints > 25 then TBPoints := 25;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----CWG Collector-----------------------------------------------------------
//CWG - CWG koleka
//------------------------------------------------------------------------------
procedure BG_CWG(CWG : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '50,100,200,300,500,800,1200,1800,';
  kouskovac(lmt,limity,',');      
  name := _('The CWG Collector');
  imgbasename := 'CWG';
  units := '';
  comment := '';
  //SQL
  //hodnota
  bgCWGCacher := CWG;
  //podminky a vystupy
  CreateResult(bgCWGCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgCWG.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Autor--------------------------------------------------------------------
//Author - prmrn dlka logu
//------------------------------------------------------------------------------
procedure BG_Author(Author : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '30,40,50,60,70,80,90,100,';
  kouskovac(lmt,limity,',');      
  name := _('The Author');
  imgbasename := 'Author';
  units := '';
  comment := '';
  //SQL
  //hodnota
  bgAuthorCacher := Author;
  //podminky a vystupy
  CreateResult(bgAuthorCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgAuthor.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Veteran--------------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_Veteran();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '3,4,6,8,10,14,17,20,';
  kouskovac(lmt,limity,',');      
  name := _('The Caching Veteran');
  imgbasename := 'Vete';
  units := '';
  comment := '';
  //SQL
  sql := 'SELECT COUNT(*) cnt FROM (SELECT distinct substr(CAST(dtfound as text),1,4) FROM geocache WHERE dtfound > 0)';
  //hodnota
  bgVeteCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgVeteCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgVeteran.checked);
  Inc(cnt);
  VeteranPoints := bgVeteCacher * 2;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Night-Owl----------------------------------------------------------------
//NOwl - non kee + SQL
//------------------------------------------------------------------------------
procedure BG_NightOwl(NOwl : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
  vsql: integer;
begin
  //inicializace
  limity := '4,10,20,30,50,80,120,180,';
  kouskovac(lmt,limity,',');      
  name := _('The Night-Owl');
  imgbasename := 'NightOwl';
  units := '';
  comment := '';
  //SQL
  sql := 'select count(gc.id) from geocache gc';
  sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''attribute''))';
  sql := sql + ' where gc.dtfound > 0 and gt.ptrvalue = (select key from geotagvalue where value = ''nightcache-yes'')';
  //hodnota
  vsql := GEOGET_DB.GetTableValue(sql);
  if NOwl <> 0 then
	bgNightOwlCacher := NOwl				//Je-li hodnota nastavena v settingu bere se nastaven
  else
    bgNightOwlCacher := vsql;				//jinak se vythne z DB z TAGu Svetlo/Tma
  //podminky a vystupy
  CreateResult(bgNightOwlCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgOwl.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Night Cacher-------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_NightCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '40,80,150,250,350,450,550,700,';
  kouskovac(lmt,limity,',');      
  name := _('The Night Cacher');
  imgbasename := 'DayNight';
  units := '';
  comment := '';
  //SQL
  //sql := 'select CAST(round(count(gc.id)*100/' + IntToStr(bgGGeocacher) + ',2) as money)';
  sql := 'select count(gc.id) cnt';
  sql := sql + ' from geocache gc';
  sql := sql + ' inner join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''SvetloTma''))';
  sql := sql + ' where gc.dtfound > 0 and gt.ptrvalue = (select key from geotagvalue where value = ''Tma'')';
  //hodnota
  bgDayNightCacher := Round(GEOGET_DB.GetTableValue(sql));
  //podminky a vystupy
  CreateResult(bgDayNightCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgNight.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);   
end;
//-----State ? Cacher-----------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_StateCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
  state_txt, state_tag: string;
  statestring, statestringcz, statestag: string;
  tmptxt : string;
  state_sl, value_sl, country_sl : TStringList;
  stag_sl: TStringList;
  state, tstate, district, tag, pomtag: string;
  i,j,ii, cnt: integer;
  correct, ccorrect: boolean;
  table: TSQLiteTable;				//Tabulka
begin
  //inicializace
  limity := '10,15,20,30,40,50,75,100,';
  kouskovac(lmt,limity,',');      
  name := _('State Badges');
  imgbasename := '';
  units := '%';
  comment := '';
  //--------
  CountryPoints := 0;
  //Priprava
  //Sthnout nebo otevt statelist.txt
  //nov (pedpokld asi pouziti polygonu) 
  statestring:='http://badgegen.com/badgescripts/statelist.txt';
  statestringcz:='http://www.geotrebic.cz/b/statelist.txt';
  statestag:='http://www.geotrebic.cz/b/statestag.txt';
  //pvodn (obsahuje jen ty co jsou rozsekan na gc.com)
  //statestring:='http://kylemills.net/Geocaching/BadgeGen/badgescripts/statelist.txt'
  //STATELIST
  if HttpAsk('GET', statestring, '', '', state_txt) then begin
	//ulo data
	if FileExists(GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt') then begin
		if DeleteFile(GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt') then
			StringToFile(state_txt,GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt');
	end
	else
		StringToFile(state_txt,GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt');
  end
  else begin
	if HttpAsk('GET', statestringcz, '', '', state_txt) then begin
		//ulo data
		if FileExists(GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt') then begin
			if DeleteFile(GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt') then
				StringToFile(state_txt,GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt');
		end
		else
			StringToFile(state_txt,GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt');
	end
	else begin
		if FileExists(GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt') then begin
			state_txt := FileToString(GEOGET_SCRIPTDIR + '\BadgeGenII\statelist.txt');
		end
		else begin
			Showmessage(_('Could not download or open:') + ' statelist.txt' );
			exit;
		end;
	end;
  end;
  //state TAG
  if HttpAsk('GET', statestag, '', '', state_tag) then begin
	//ulo data
	if FileExists(GEOGET_SCRIPTDIR + '\BadgeGenII\statestag.txt') then begin
//Arne1
		if DeleteFile(GEOGET_SCRIPTDIR + '\BadgeGenII\statestag.txt') then
//Arne1
			StringToFile(state_tag,GEOGET_SCRIPTDIR + '\BadgeGenII\statestag.txt');
			state_tag := FileToString(GEOGET_SCRIPTDIR + '\BadgeGenII\statestag.txt');
	end
	else
		StringToFile(state_tag,GEOGET_SCRIPTDIR + '\BadgeGenII\statestag.txt');
  end
  else begin
	Showmessage(_('Could not download or open:') + ' statestag.txt');
  end;
  //Pprava etzce
  country_sl := TStringList.Create;
  state_sl := TStringList.Create;
  value_sl := TStringList.Create;
  stag_sl := TStringList.Create; 
  //------------------------------------------
  try
	  sql := 'select distinct country from geocache gc where gc.[dtfound]>0';
	  //
	  table := GEOGET_DB.GetTable(sql, false);
	  //
	  try
		while not table.Eof do begin
			tmptxt := UtfToAnsi(table.FieldAsString(0));
			country_sl.Add(tmptxt);
			table.Next;
		end;
	  finally
		if(table <> nil) then table.Free();
	  end;
	  
	  ParseDelimited(state_sl, state_txt, #13#10);								//CRLF
	  if state_sl.Count <= 1 then ParseDelimited(state_sl, state_txt, #10);		//LF
	  //
	  ParseDelimited(stag_sl, state_tag, #13#10);								//CRLF
	  if stag_sl.Count <= 1 then ParseDelimited(stag_sl, state_tag, #10);		//LF
	  //
	  //zpracovn jednotlivch zem
	  for i := 0 to state_sl.Count-1 do begin
		comment := '';
		ccorrect := false;
		state := SeparateLeft(state_sl[i],',');
		//
		for j := 0 to country_sl.Count-1 do begin
			if state = country_sl[j] then begin
				ccorrect := true;
				break;
			end;
		end;
		//
		if not ccorrect then continue;	//------------------>> dal stt
		//
		//if state = 'Vatican City State' then Showmessage(state + ' ' + GetCountryAbbr(state));
		imgbasename := iso2toiso3(GetCountryAbbr(state));
		district := SeparateRight(state_sl[i],',');
		tag := '';
		if stag_sl.Count > 0 then begin
		  for ii := 0 to stag_sl.Count-1 do begin
			tstate := SeparateLeft(stag_sl[ii],',');
			if state = tstate then begin
				pomtag := ReplaceString(stag_sl[ii], state + ',', '');
				tag := SeparateLeft(pomtag,',');
				district := SeparateRight(pomtag,',');
				break;
			end
		  end;
		end;
		value_sl.clear;
		if tag = '' then begin
			//SQL
			sql := 'select CAST(CAST(round((ctr.cnt*100.00)/' + district + ',2) as money) as varchar)||'', ''||';
			sql := sql + 'CAST(ctr.cnt as varchar)||'', ''||CAST(ctr.country as varchar)||'', ''||CAST(ctr.states as varchar)';
			sql := sql + ' from (';
			sql := sql + ' select country, max(cnt) as cnt, group_concat(states,'' + '') as states from (';
			sql := sql + ' select country,1 as cnt,''?'' as states from geocache where dtfound>0 and state='''' group by country';
			sql := sql + ' union';
			sql := sql + ' select country, count(state) as cnt, group_concat(state,'', '') as states from (';
			sql := sql + ' select country,state from geocache where dtfound>0 and state!='''' group by country,state';
			sql := sql + ') group by country order by states asc';
			sql := sql + ') group by country';
			sql := sql + ') ctr where ctr.country = ''' + state + '''';
			//sql := sql + ' order by ctr.country';
			
			try
				tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
				//if state = 'Austria' then Showmessage(tmptxt);
				while tmptxt <> '' do begin
					value_sl.Add(Fetch(tmptxt,','));
				end;
			except
				value_sl.clear;
			end;

			if Trim(value_sl.text) <> '' then begin
				for j := 3 to value_sl.count-1 do comment := comment + value_sl[j] + ', ';
				comment := '[' + comment + ' ' + value_sl[1] + '/' + district + ']';
				name := 'The ' + value_sl[2] + ' Cacher';	
				//Vytvo odznak
				Inc(CountryPoints);
				CreateResult(Round(StrToFl(value_sl[0])), lmt, name, imgbasename, units, comment, True, True, BGSForm_chbgState.checked)			
			end;
		end
		else begin
			//SQL
			sql := 'select gc.country as country, "?" as state, count(country) as cnt';
			sql := sql + ' from geocache gc';
			sql := sql + ' left join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''' + tag + '''))';
			sql := sql + ' where dtfound>0 and gt.ptrvalue = null';
			sql := sql + ' group by gc.country';
			sql := sql + ' union';
            sql := sql + ' select gc.country, Trim(gv.value) as state, count(Trim(gv.value)) as cnt';
			sql := sql + ' from geocache gc';
			sql := sql + ' inner join geotag gt ON gt.id = gc.id and gt.ptrkat = (select key from geotagcategory where value = ''' + tag + ''')';
			sql := sql + ' inner join geotagvalue gv ON gv.key = gt.ptrvalue';
			sql := sql + ' where gc.dtfound>0 and gc.country = ''' + state + ''' and state is not null';
			sql := sql + ' group by gc.country, Trim(gv.value)';
			//
			//ShowHTMLMessage('test',sql);
			table := GEOGET_DB.GetTable(sql, false);
			//
			try
				cnt := 0;
				while not table.Eof do begin
					tmptxt := UtfToAnsi(table.FieldAsString(1));
					correct := true;
					//nepochopiteln prava - obas se nkter kraje zdvoj ?!?!--------------------
					if Trim(value_sl.text) <> '' then begin						
						for j := 0 to value_sl.count-1 do begin
							if tmptxt = value_sl[j] then begin
								correct := false;
								break;
							end;
						end;
					end;
					//
					if correct then begin
						if tmptxt <> '?' then Inc(cnt);
						value_sl.Add(tmptxt);
					end;
					//------------------------------------------------------------------------------
					table.Next;
				end;
			finally
				if(table <> nil) then table.Free();
			end;
			//
			if Trim(value_sl.text) <> '' then begin
				for j := 0 to value_sl.count-1 do comment := comment + value_sl[j] + ', ';
				comment := '[' + comment + ' ' + IntToStr(cnt) + '/' + district + ']';
				name := 'The ' + state + ' Cacher';	
				//Vytvo odznak
				Inc(CountryPoints);
				CreateResult(Round(cnt*100.00/StrToInt(district)), lmt, name, imgbasename, units, comment, True, True, BGSForm_chbgState.checked)			
			end;
		end;	
	  end;
	  //
	  Inc(cnt);
	  GeoBusyProgress(cnt, max_bg); 
  finally
	  country_sl.Free;
	  state_sl.Free;
	  value_sl.Free;
	  stag_sl.Free;
  end;
end;
//-----Europe Cacher------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_EuropeCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql, tmptxt : String;				//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '4,6,9,14,19,25,34,45,';
  kouskovac(lmt,limity,',');      
  name := _('The Europe Cacher');
  imgbasename := 'Evro';
  units := '';
  //SQL
  sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
  sql := sql + ' from';
  sql := sql + ' (select gc.country as country';
  sql := sql + ' from geocache gc';
  sql := sql + ' where gc.dtfound>0';
  sql := sql + ' and gc.country in (''Aland Islands'',''Albania'',''Andorra'',''Austria'',''Belgium'',''Belarus'',''Bosnia and Herzegovina'',''Bulgaria'',''Croatia'',''Czech Republic'',''Denmark'',';
  sql := sql + '''Estonia'',''Finland'',''Germany'',''Gibraltar'',''Greece'',''Faroe Islands'',''France'',''Hungary'',''Iceland'',''Ireland'',''Italy'',''Kazakhstan'',';
  sql := sql + '''Latvia'',''Liechtenstein'',''Lithuania'',''Luxembourg'',''Macedonia'',''Malta'',''Moldova'',''Monaco'',''Montenegro'',''Netherlands'',';
  sql := sql + '''Norway'',''Poland'',''Portugal'',''Romania'',''Russian Federation'',''San Marino'',''Serbia'',''Slovakia'',''Slovenia'',''Spain'',';
  sql := sql + '''Sweden'',''Switzerland'',''Turkey'',''United Kingdom'',''Ukraine'',''Vatican City State'')';
  sql := sql + ' group by gc.country) as cnt';
  //hodnota
  tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
  bgEuropaCacher := Round(StrToFl(Fetch(tmptxt,',')));
  while tmptxt <> '' do begin
		comment := comment + Fetch(tmptxt,',') + ', ';
  end;
  comment := '[' + comment + ' ' + IntToStr(bgEuropaCacher) + '/49]';
  //podminky a vystupy
  CreateResult(bgEuropaCacher, lmt, name, imgbasename, units, comment, True, True, BGSForm_chbgEurope.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);   
end;
//-----EU Cacher----------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_EUCacher();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql, tmptxt : String;				//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '3,4,6,8,11,15,19,26,';
  kouskovac(lmt,limity,',');      
  name := _('The EU Cacher');
  imgbasename := 'EUR';
  units := '';
  //SQL
  sql := 'select CAST(count(cnt.country) as varchar)||'', ''||CAST(group_concat(cnt.country, '', '') as varchar)';
  sql := sql + ' from';
  sql := sql + ' (select gc.country as country';
  sql := sql + ' from geocache gc';
  sql := sql + ' where gc.dtfound>0';
  sql := sql + ' and gc.country in (''Austria'',''Belgium'',''Bulgaria'',''Cyprus'',''Croatia'',''Czech Republic'',';
  sql := sql + '''Denmark'',''Estonia'',''Finland'',''Germany'',''Greece'',';
  sql := sql + '''France'',''Hungary'',''Ireland'',''Italy'',''Latvia'',';
  sql := sql + '''Lithuania'',''Luxembourg'',''Malta'',''Netherlands'',''Poland'',';
  sql := sql + '''Portugal'',''Romania'',''Slovakia'',''Slovenia'',''Spain'',';
  sql := sql + '''Sweden'',''United Kingdom'')';
  sql := sql + ' group by gc.country) as cnt';
  //hodnota
  tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
  bgEUCacher := Round(StrToFl(Fetch(tmptxt,',')));
  while tmptxt <> '' do begin
		comment := comment + Fetch(tmptxt,',') + ', ';
  end;
  comment := '[' + comment + ' ' + IntToStr(bgEUCacher) + '/28]';
  //podminky a vystupy
  CreateResult(bgEUCacher, lmt, name, imgbasename, units, comment, True, True, BGSForm_chbgEU.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);   
end;
//-----The Favourite Cacher-----------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_FPCacher(CacheID:String);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '25,40,60,90,150,210,320,500,';
  kouskovac(lmt,limity,',');      
  name := _('The Favourite Cacher');
  imgbasename := 'Favo';
  units := '';
  comment := '';
  //SQL
  sql := 'SELECT SUM(CAST((SELECT value FROM geotagvalue WHERE key = gt.ptrvalue) AS int))';
  sql := sql + ' FROM geocache gc';
  sql := sql + ' INNER JOIN geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''favorites''))';
  sql := sql + ' WHERE gc.id in (' + CacheID + ')';
  //hodnota
  bgFPCacher := GEOGET_DB.GetTableValue(sql);
  //podminky a vystupy
  CreateResult(bgFPCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgFP.checked);
  Inc(cnt);
  FPPoints := bgFPCacher * 0.1;
  GeoBusyProgress(cnt, max_bg);  
end;
//-----Shutterbug---------------------------------------------------------------
//Poet fotek pidanch k logm
//------------------------------------------------------------------------------
procedure BG_Photo(Photo : int64);
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '50,75,150,250,500,750,1500,2500,';
  kouskovac(lmt,limity,',');      
  name := _('The Shutterbug');
  imgbasename := 'Phot';
  units := '';
  comment := '';
  //SQL
  //hodnota
  bgPhotoCacher := Photo;
  //podminky a vystupy
  CreateResult(bgPhotoCacher, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgPhoto.checked);
  Inc(cnt);
  PhotoPoints := Photo * 0.1;
  if PhotoPoints > 25 then PhotoPoints := 25;
  GeoBusyProgress(cnt, max_bg);
end;
//-----CZ District--------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_CZDistrict();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql, tmptxt : String;				//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '15,20,30,40,50,60,75,77,';
  kouskovac(lmt,limity,',');      
  name := _('The CZ District Cacher');
  imgbasename := 'CZDist';
  units := '';
  //SQL
  sql := 'SELECT CAST(count(result.name) as varchar)||", "||CAST(group_concat(result.name, ", ") as varchar)';
  sql := sql + ' FROM (SELECT DISTINCT (SELECT CASE WHEN (value LIKE "Praha %") THEN "Praha" ELSE value END val';
  sql := sql + ' FROM geotagvalue WHERE key = gt.ptrvalue) name'; 
  sql := sql + ' FROM (SELECT *';
  sql := sql + ' FROM geocache gc';
  sql := sql + ' WHERE gc.dtfound > 0) f';
  sql := sql + ' INNER JOIN geotag gt on (f.id = gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "CZ okres" COLLATE NOCASE))';
  sql := sql + ' GROUP BY ptrvalue';
  sql := sql + ' ORDER BY name COLLATE NOCASE) result';
  //hodnota
  tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
  bgCZDistrict := Round(StrToFl(Fetch(tmptxt,',')));
  while tmptxt <> '' do begin
		comment := comment + Fetch(tmptxt,',') + ', ';
  end;
  comment := '[' + comment + ' ' + IntToStr(bgCZDistrict) + '/77]';
  //podminky a vystupy
  CreateResult(bgCZDistrict, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgCZDistrict.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;

//-----SK District--------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_SKDistrict();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql, tmptxt : String;				//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '15,20,30,40,50,60,75,79,';
  kouskovac(lmt,limity,',');      
  name := _('The SK District Cacher');
  imgbasename := 'SKDist';
  units := '';
  //SQL
  sql := 'SELECT CAST(count(result.name) as varchar)||'', ''||CAST(group_concat(result.name, ", ") as varchar)';
  sql := sql + ' FROM (SELECT (SELECT value FROM geotagvalue WHERE key = gt.ptrvalue) name';
  sql := sql + ' FROM (SELECT *';
  sql := sql + ' FROM geocache gc';
  sql := sql + ' WHERE gc.dtfound > 0) f';
  sql := sql + ' INNER JOIN geotag gt on (f.id = gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "SK okres" COLLATE NOCASE))';
  sql := sql + ' GROUP BY ptrvalue';
  sql := sql + ' ORDER BY name COLLATE NOCASE) result';
  //hodnota
  tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
  bgSKDistrict := Round(StrToFl(Fetch(tmptxt,',')));
  while tmptxt <> '' do begin
		comment := comment + Fetch(tmptxt,',') + ', ';
  end;
  comment := '[' + comment + ' ' + IntToStr(bgSKDistrict) + '/79]';
  //podminky a vystupy
  CreateResult(bgSKDistrict, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgSKDistrict.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;

//-----AU Bezerk----------------------------------------------------------------
//SQL
//------------------------------------------------------------------------------
procedure BG_ATBezirk();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql, tmptxt : String;				//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '16,21,32,42,53,64,78,95,';
  kouskovac(lmt,limity,',');      
  name := _('The AT Bezirk Cacher');
  imgbasename := 'ATBez';
  units := '';
  //SQL
  sql := 'SELECT CAST(count(result.name) as varchar)||'', ''||CAST(group_concat(result.name, ", ") as varchar)';
  sql := sql + ' FROM (SELECT (SELECT value FROM geotagvalue WHERE key = gt.ptrvalue) name';
  sql := sql + ' FROM (SELECT *';
  sql := sql + ' FROM geocache gc';
  sql := sql + ' WHERE gc.dtfound > 0) f';
  sql := sql + ' INNER JOIN geotag gt on (f.id = gt.id and gt.ptrkat IN (SELECT key FROM geotagcategory WHERE value = "AT Bezirk" COLLATE NOCASE))';
  sql := sql + ' GROUP BY ptrvalue';
  sql := sql + ' ORDER BY name COLLATE NOCASE) result';
  //hodnota
  tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
  bgATBezirk := Round(StrToFl(Fetch(tmptxt,',')));
  while tmptxt <> '' do begin
		comment := comment + Fetch(tmptxt,',') + ', ';
  end;
  comment := '[' + comment + ' ' + IntToStr(bgATBezirk) + '/95]';
  //podminky a vystupy
  CreateResult(bgATBezirk, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgATBezirk.checked);
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg);
end;

//-----Unique Types in a day----------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_UniqTypesADay();
var
  name : String;					//jmno odznku reln
  imgbasename : String;				//bzov jmno vlastnho obrzku
  units,comment : String;	  		//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql : String;						//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '5,0,6,7,8,9,0,10,';
  kouskovac(lmt,limity,',');      
  name := _('The Diverse Cacher');
  imgbasename := 'Uniq';
  units := '';
  //SQL
  sql := 'SELECT max(cntx)';
  sql := sql + ' FROM (SELECT count(gg.dtf) cntx';
  sql := sql + ' FROM (SELECT gc.[dtfound] dtf, count(gc.cachetype) max';
  sql := sql + ' FROM geocache gc';
  sql := sql + ' WHERE gc.dtfound > 0';
  sql := sql + ' GROUP BY gc.dtfound, gc.[cachetype]) gg';
  sql := sql + ' GROUP BY gg.dtf)';
  //
  {sql := 'select max(cntx) max';
  sql := sql + ' from (select count(dtf) cntx';
  sql := sql + ' from (select count(gg.found) cnt, gg.found dtf';
  sql := sql + ' from (select (case when gc.cachetype = ''Cache In Trash Out Event'' then ''Event'' else (case when gc.cachetype = ''Event Cache'' then ''Event'' else';
  sql := sql + ' (case when gc.cachetype = ''Mega-Event Cache'' then ''Event'' else (gc.cachetype) end) end) end) type, gc.dtfound found';
  sql := sql + ' from geocache gc';
  sql := sql + ' where gc.dtfound > 0 and gc.cachetype <> ''Project APE Cache'' and gc.cachetype <> ''Lost and Found Event Cache'') gg';
  sql := sql + ' group by gg.found, gg.type)';
  sql := sql + ' group by dtf)';}
  //hodnota
  bgUniqueTypesInDay := Round(GEOGET_DB.GetTableValue(sql));
  //podminky a vystupy
  CreateResult(bgUniqueTypesInDay, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgUniq.checked);
  Inc(cnt);
  FDistPoints := bgUniqueTypesInDay * 2;
  GeoBusyProgress(cnt, max_bg);   
end;
//-----Waymarker----------------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_Waymarker();
var
  name : String;							//jmno odznku reln
  imgbasename : String;						//bzov jmno vlastnho obrzku
  units,comment : String;	  				//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql,actualdb, newdb, tmpdb : String;		//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  if BGSForm_chbUS.checked then begin
	limity := '20,30,50,80,120,180,250,350,';			//Originl USA
	name := _('The Waymarker');
  end
  else begin
	limity := '100,200,300,500,800,1200,1800,2500,';	//CZ
	name := _('The Waymarker CZ');
  end;
  kouskovac(lmt,limity,',');
  //name := _('The Waymarker');
  imgbasename := 'Waym';
  units := '';
  comment := '';
  {//Change DB
  actualdb := GEOGET_DBNAME;
  tmpdb := BGSForm_cbDB.Items[BGSForm_cbDB.ItemIndex];
  newdb := Fetch(tmpdb,'.');
  try
    if not ((actualdb = newdb) or (tmpdb = '')) then begin
	  try
		GeoDBSelect(newdb);
	  except
	    Showmessage(_('Error when switching database: ') + newdb);
	  end;
	end;}
	//SQL
	sql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.id like ''WM%'''
	//hodnota
	if (DruhaDB <> nil) then
		bgWaymarker := DruhaDB.GetTableValue(sql)
	else
		bgWaymarker := GEOGET_DB.GetTableValue(sql);
	//podminky a vystupy
	CreateResult(bgWaymarker, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgWaymarking.checked);
	//Vrt databzi
  {finally
    if not ((actualdb = newdb) or (tmpdb = '')) then begin
	  try
		GeoDBSelect(actualDB);
	  except
	    Showmessage(_('Error when switching database: ') + actualDB);
	  end;
	end;
  end;}
  //
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg); 
end;
//-----Waymarker-author---------------------------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_WaymarkerCr();
var
  name : String;							//jmno odznku reln
  imgbasename : String;						//bzov jmno vlastnho obrzku
  units,comment : String;	  				//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql,actualdb, newdb, tmpdb : String;		//SQL dotaz
  limity : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '40,100,200,300,500,700,1000,1500,';
  kouskovac(lmt,limity,',');
  name := _('The Waymark Author');
  imgbasename := 'WMaut';
  units := '';
  comment := '';
  {//Change DB
  actualdb := GEOGET_DBNAME;
  tmpdb := BGSForm_cbDB.Items[BGSForm_cbDB.ItemIndex];
  newdb := Fetch(tmpdb,'.');
  try
    if not ((actualdb = newdb) or (tmpdb = '')) then begin
	  try
		GeoDBSelect(newdb);
	  except
	    Showmessage(_('Error when switching database: ') + newdb);
	  end;
	end;}
	//SQL
	sql := 'select count(gc.id) from geocache gc where gc.author LIKE ''%' + AnsiToUtf(GEOGET_OWNER) + '%'' and gc.id LIKE ''WM%'''
	//hodnota
	if (DruhaDB <> nil) then
		bgWaymarkCreator := DruhaDB.GetTableValue(sql)
	else
		bgWaymarkCreator := GEOGET_DB.GetTableValue(sql);
	//podminky a vystupy
	CreateResult(bgWaymarkCreator, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgWaymarkingCr.checked);
	//Vrt databzi
  {finally
    if not ((actualdb = newdb) or (tmpdb = '')) then begin
	  try
		GeoDBSelect(actualDB);
	  except
	    Showmessage(_('Error when switching database: ') + actualDB);
	  end;
	end;
  end;}
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg); 
end;
//-----The Waymark categories discoverer----------------------------------------
//SQL dotaz
//------------------------------------------------------------------------------
procedure BG_WCDiscoverer();
var
  name : String;							//jmno odznku reln
  imgbasename : String;						//bzov jmno vlastnho obrzku
  units,comment : String;	  				//jednotky pokud je poteba je zobrazit (km, m, %), koment
  sql,actualdb, newdb, tmpdb : String;		//SQL dotaz
  limity {, tmptxt} : String;
  lmt : TLimit;
begin
  //inicializace
  limity := '40,80,150,250,350,450,550,700,';
  kouskovac(lmt,limity,',');
  name := _('The Waymark categories discoverer');
  imgbasename := 'WCat';
  units := '';
  comment := '';
  {//Change DB
  actualdb := GEOGET_DBNAME;
  tmpdb := BGSForm_cbDB.Items[BGSForm_cbDB.ItemIndex];
  newdb := Fetch(tmpdb,'.');
  try
    if not ((actualdb = newdb) or (tmpdb = '')) then begin
	  try
		GeoDBSelect(newdb);
	  except
	    Showmessage(_('Error when switching database: ') + newdb);
	  end;
	end;}
	//SQL
	//sql := 'select CAST(count(ctype) as varchar)||'', ''||CAST(group_concat(ctype, '', '') as varchar) result'
	sql := 'select count(ctype) result';
	sql := sql + ' from (';
	sql := sql + ' select distinct ctype';
	sql := sql + ' from (';
	sql := sql + ' select gc.[cachetype] ctype';
	sql := sql + ' from geocache gc';
	sql := sql + ' where dtfound > 0 and gc.id LIKE ''WM%''';
	sql := sql + ' union all';
	sql := sql + ' select gc.[cachetype] ctype';
	sql := sql + ' from geocache gc';
	sql := sql + ' where gc.author LIKE ''%' + AnsiToUtf(GEOGET_OWNER) + '%'' and gc.id LIKE ''WM%'')';
	sql := sql + ' order by ctype)';
	//hodnota
	//tmptxt := UtfToAnsi(GEOGET_DB.GetTableString(sql));
	//bgWaymarkCategory := Round(StrToFl(Fetch(tmptxt,',')));
	//while tmptxt <> '' do begin
	//	comment := comment + Fetch(tmptxt,',') + ', ';
	//end;
	//comment := '[' + comment + ']';
	if (DruhaDB <> nil) then
		bgWaymarkCategory := DruhaDB.GetTableValue(sql)
	else
		bgWaymarkCategory := GEOGET_DB.GetTableValue(sql);
	//podminky a vystupy
	CreateResult(bgWaymarkCategory, lmt, name, imgbasename, units, comment, True, False, BGSForm_chbgWCDiscover.checked);
	//Vrt databzi
  {finally
    if not ((actualdb = newdb) or (tmpdb = '')) then begin
	  try
		GeoDBSelect(actualDB);
	  except
	    Showmessage(_('Error when switching database: ') + actualDB);
	  end;
	end;
  end;}
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg); 
end;
//******************************************************************************
//								B E L T S
//******************************************************************************
procedure Belts();
var
  belt, imgname, basename: String;
  events, caches, count, states: integer;
  p1, p2: integer;
  yes, no: string;
  ihtml, spc : string;
  sql : string;
begin
  belt := 'White';
  basename := 'Belt_';
  yes := 'http://www.geocaching.com/images/silk/tick.png';
  no := 'http://www.geocaching.com/images/stockholm/16x16/cross.gif';
  spc := '&nbsp;&nbsp;&nbsp;'
  //
  events := bgEvenCacher + bgMegaCacher + bgCITOCacher;
  caches := bgGGeocacher - events;
  count := bgCounCacher;
  //
  sql := 'select count(cnt) from';
  sql := sql + ' (select count(gc.id) cnt';
  sql := sql + ' from geocache gc';
  sql := sql + ' where gc.dtfound > 0 and gc.state <> ''''';
  sql := sql + ' group by gc.state)';
  //
  states := GEOGET_DB.GetTableValue(sql);
  //Pokud je americk potn potaj se pro psky (states = Kraje)
  //Pokud je evropsk potn nahrazuje se states polokou country co vce vypovd
  if BGSForm_chbUS.checked then count := states;
  //p1
  p1 := 0;
  if bgFTFCacher > 49 then Inc(p1);
  if bgCounCacher > 3 then Inc(p1);
  if bgMatrCacher > 71 then Inc(p1);
  if bgFiveCacher > 0 then Inc(p1);
  if StrToInt(CountDaily) > 29 then Inc(p1);
  if bgTwenCacher > 49 then Inc(p1);
  if bgElevCacher > 999 then Inc(p1);
  if CountOwnerType > 2 then Inc(p1);
  if gold > 2 then Inc(p1);
  if StrToFl(CountDailyDist) > 500 then Inc(p1);
  //p2
  p2 := 0;
  if bgFTFCacher > 49 then Inc(p2);
  if bgCounCacher > 7 then Inc(p2);
  if bgMatrCacher = 81 then Inc(p2);
  if bgFiveCacher > 0 then Inc(p2);
  if StrToInt(CountDaily) > 49 then Inc(p2);
  if bgTwenCacher > 49 then Inc(p2);
  if bgElevCacher > 999 then Inc(p2);
  if CountOwnerType > 4 then Inc(p2);
  if gold > 2 then Inc(p2);
  if StrToFl(CountDailyDist) > 500 then Inc(p2);
  //
  if (caches > 99)   and (bgHiddCacher > 4) then belt := 'Yellow';
  if (caches > 299)  and (bgHiddCacher > 9) then belt := 'Orange';
  if (caches > 499)  and (bgHiddCacher > 14) and (events > 0) and (count > 1) then belt := 'Green';
  if (caches > 999)  and (bgHiddCacher > 19) and (events > 2) and (count > 3) then belt := 'Blue';
  if (caches > 1999) and (bgHiddCacher > 49) and (events > 2) and (count > 7) and (bgHostCacher > 0) and (p1 > 4) then belt := 'Brown';
  if (caches > 2999) and (bgHiddCacher > 49) and (events > 2) and (count > 7) and (bgHostCacher > 0) and (p2 > 7) then belt := 'Black';
  //
  bgBelt := belt;
  //
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + bgBelt;
  if BGSForm_chbBeltShow.checked then
	htmlBelt := '<img src="' + imgname + '.png" width="' + Trim(IntToStr(Round((175 * StrToInt(BGSForm_edBBSize.Text))/100.0))) + '" title="Belt - ' + bgBelt + '" />'
  else
	htmlBelt := '';
  //info html
  //white:
  belt := 'White';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This is awarded if a cacher doesn''t qualify for another colour belt'; 
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;
  //yellow
  belt := 'Yellow';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This awarded if the following conditions are met:<br />';
  if caches > 99 then
	ihtml := ihtml + '<img src="' + yes + '" /> 100 cache finds (any type) <font color="blue">(' + IntToStr(caches) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 100 cache finds (any type) <font color="red">(' + IntToStr(caches) + ')</font> <b>AND</b><br />';
  if bgHiddCacher > 4 then
	ihtml := ihtml + '<img src="' + yes + '" /> 5 cache hides <font color="blue">(' + IntToStr(bgHiddCacher) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 5 cache hides <font color="red">(' + IntToStr(bgHiddCacher) + ')</font><br />';
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;
  //yellow
  belt := 'Orange';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This awarded if the following conditions are met:<br />';
  if caches > 299 then
	ihtml := ihtml + '<img src="' + yes + '" /> 300 cache finds (any type) <font color="blue">(' + IntToStr(caches) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 300 cache finds (any type) <font color="red">(' + IntToStr(caches) + ')</font> <b>AND</b><br />';
  if bgHiddCacher > 9 then
	ihtml := ihtml + '<img src="' + yes + '" /> 10 cache hides <font color="blue">(' + IntToStr(bgHiddCacher) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 10 cache hides <font color="red">(' + IntToStr(bgHiddCacher) + ')</font><br />';
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;
  //green
  belt := 'Green';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This awarded if the following conditions are met:<br />';
  if caches > 499 then
	ihtml := ihtml + '<img src="' + yes + '" /> 500 cache finds (any type) <font color="blue">(' + IntToStr(caches) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 500 cache finds (any type) <font color="red">(' + IntToStr(caches) + ')</font> <b>AND</b><br />';
  if bgHiddCacher > 14 then
	ihtml := ihtml + '<img src="' + yes + '" /> 15 cache hides <font color="blue">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 15 cache hides <font color="red">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />';
  if events > 0 then
	ihtml := ihtml + '<img src="' + yes + '" /> 1 event (any type) attended <font color="blue">(' + IntToStr(events) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 1 event (any type) attended <font color="red">(' + IntToStr(events) + ')</font> <b>AND</b><br />';
  if count > 1 then
	ihtml := ihtml + '<img src="' + yes + '" /> at least one cache find in 2 distinct states <font color="blue">(' + IntToStr(count) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> at least one cache find in 2 distinct states <font color="red">(' + IntToStr(count) + ')</font><br />';
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;  
  //blue
  belt := 'Blue';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This awarded if the following conditions are met:<br />';
  if caches > 999 then
	ihtml := ihtml + '<img src="' + yes + '" /> 1000 cache finds (any type) <font color="blue">(' + IntToStr(caches) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 1000 cache finds (any type) <font color="red">(' + IntToStr(caches) + ')</font> <b>AND</b><br />';
  if bgHiddCacher > 19 then
	ihtml := ihtml + '<img src="' + yes + '" /> 20 cache hides <font color="blue">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 20 cache hides <font color="red">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />';
  if events > 2 then
	ihtml := ihtml + '<img src="' + yes + '" /> 3 event (any type) attended <font color="blue">(' + IntToStr(events) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 3 event (any type) attended <font color="red">(' + IntToStr(events) + ')</font> <b>AND</b><br />';
  if count > 3 then
	ihtml := ihtml + '<img src="' + yes + '" /> at least one cache find in 4 distinct states <font color="blue">(' + IntToStr(count) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> at least one cache find in 4 distinct states <font color="red">(' + IntToStr(count) + ')</font><br />';
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;
  //brown
  belt := 'Brown';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This awarded if the following conditions are met:<br />';
  if caches > 1999 then
	ihtml := ihtml + '<img src="' + yes + '" /> 2000 cache finds (any type) <font color="blue">(' + IntToStr(caches) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 2000 cache finds (any type) <font color="red">(' + IntToStr(caches) + ')</font> <b>AND</b><br />';
  if bgHiddCacher > 49 then
	ihtml := ihtml + '<img src="' + yes + '" /> 50 cache hides <font color="blue">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 50 cache hides <font color="red">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />';
  if events > 2 then
	ihtml := ihtml + '<img src="' + yes + '" /> 3 event (any type) attended <font color="blue">(' + IntToStr(events) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 3 event (any type) attended <font color="red">(' + IntToStr(events) + ')</font> <b>AND</b><br />';
  if count > 7 then
	ihtml := ihtml + '<img src="' + yes + '" /> at least one cache find in 8 distinct states <font color="blue">(' + IntToStr(count) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> at least one cache find in 8 distinct states <font color="red">(' + IntToStr(count) + ')</font> <b>AND</b><br />';
  if bgHostCacher > 0 then	
	ihtml := ihtml + '<img src="' + yes + '" /> hosted one event (any type) <font color="blue">(' + IntToStr(bgHostCacher) + ')</font> <b>AND</b><br />'
  else
	ihtml := ihtml + '<img src="' + no + '" /> hosted one event (any type) <font color="red">(' + IntToStr(bgHostCacher) + ')</font> <b>AND</b><br />';
  if p1 > 4 then
    ihtml := ihtml + '<img src="' + yes + '" /> any 5 of the following conditions are met: <font color="blue">(' + IntToStr(p1) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> any 5 of the following conditions are met: <font color="red">(' + IntToStr(p1) + ')</font><br />';
  if bgFTFCacher > 49 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least 50 FTFs <font color="blue">(' + IntToStr(bgFTFCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least 50 FTFs <font color="red">(' + IntToStr(bgFTFCacher) + ')</font></span><br />';
  if bgCounCacher > 3 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least one find in 4 distinct countries <font color="blue">(' + IntToStr(bgCounCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least one find in 4 distinct countries <font color="red">(' + IntToStr(bgCounCacher) + ')</font></span><br />';
  if bgMatrCacher > 71 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least 72 out of the 81 D/T combinations completed (89%) <font color="blue">(' + IntToStr(bgMatrCacher) + ')</font></span><br />'
  else
	ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least 72 out of the 81 D/T combinations completed (89%) <font color="red">(' + IntToStr(bgMatrCacher) + ')</font></span><br />';
  if bgFiveCacher > 0 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> one 5/5 D/T rated cache <font color="blue">(' + IntToStr(bgFiveCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> one 5/5 D/T rated cache <font color="red">(' + IntToStr(bgFiveCacher) + ')</font></span><br />';
  if StrToInt(CountDaily) > 29 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 30 consecutive days with a cache find <font color="blue">(' + CountDaily + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 30 consecutive days with a cache find <font color="red">(' + CountDaily + ')</font></span><br />';
  if bgTwenCacher > 49 then
    ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 50 caches found on a single day <font color="blue">(' + IntToStr(bgTwenCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 50 caches found on a single day <font color="red">(' + IntToStr(bgTwenCacher) + ')</font></span><br />';
  if bgElevCacher > 999 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least one cache found above 1000m elevation <font color="blue">(' + IntToStr(bgElevCacher) + 'm)</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least one cache found above 1000m elevation <font color="red">(' + IntToStr(bgElevCacher) + 'm)</font></span><br />';
  if CountOwnerType > 2 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 3 distinct types of caches hidden (any types incl. events) <font color="blue">(' + IntToStr(CountOwnerType) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 3 distinct types of caches hidden (any types incl. events) <font color="red">(' + IntToStr(CountOwnerType) + ')</font></span><br />';
  if gold > 2 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 3 gold badges for container size <font color="blue">(' + IntToStr(gold) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 3 gold badges for container size <font color="red">(' + IntToStr(gold) + ')</font></span><br />';
  if StrToFl(CountDailyDist) > 500 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> Maximum distance in a day of 500km or more <font color="blue">(' + CountDailyDist + 'km)</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> Maximum distance in a day of 500km or more <font color="red">(' + CountDailyDist + 'km)</font></span><br />';
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;  
  //black
  belt := 'Black';
  imgname := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + basename + belt;
  ihtml := ihtml + '<div class="BGII_BeltI" style="display:block; margin: 0 auto;">' + CRLF;
  ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + '; text-align:center;" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
  ihtml := ihtml + '<tr><td width="180px"><img src="' + imgname + '.png" title="Belt - ' + belt + '" /></td>';
  ihtml := ihtml + '<td style="text-align:left; vertical-align:baseline"><b>' + Uppercase(belt) + ':</b> This awarded if the following conditions are met:<br />';
  if caches > 2999 then
	ihtml := ihtml + '<img src="' + yes + '" /> 3000 cache finds (any type) <font color="blue">(' + IntToStr(caches) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 3000 cache finds (any type) <font color="red">(' + IntToStr(caches) + ')</font> <b>AND</b><br />';
  if bgHiddCacher > 49 then
	ihtml := ihtml + '<img src="' + yes + '" /> 50 cache hides <font color="blue">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 50 cache hides <font color="red">(' + IntToStr(bgHiddCacher) + ')</font> <b>AND</b><br />';
  if events > 2 then
	ihtml := ihtml + '<img src="' + yes + '" /> 3 event (any type) attended <font color="blue">(' + IntToStr(events) + ')</font> <b>AND</b><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> 3 event (any type) attended <font color="red">(' + IntToStr(events) + ')</font> <b>AND</b><br />';
  if count > 7 then
	ihtml := ihtml + '<img src="' + yes + '" /> at least one cache find in 8 distinct states <font color="blue">(' + IntToStr(count) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> at least one cache find in 8 distinct states <font color="red">(' + IntToStr(count) + ')</font><br />';
  if bgHostCacher > 0 then	
	ihtml := ihtml + '<img src="' + yes + '" /> hosted one event (any type) <font color="blue">(' + IntToStr(bgHostCacher) + ')</font> <b>AND</b><br />'
  else
	ihtml := ihtml + '<img src="' + no + '" /> hosted one event (any type) <font color="red">(' + IntToStr(bgHostCacher) + ')</font> <b>AND</b><br />';	
  if p2 > 7 then
    ihtml := ihtml + '<img src="' + yes + '" /> any 8 of the following conditions are met: <font color="blue">(' + IntToStr(p2) + ')</font><br />'
  else
    ihtml := ihtml + '<img src="' + no + '" /> any 8 of the following conditions are met: <font color="red">(' + IntToStr(p2) + ')</font><br />';	
  if bgFTFCacher > 49 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least 50 FTFs <font color="blue">(' + IntToStr(bgFTFCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least 50 FTFs <font color="red">(' + IntToStr(bgFTFCacher) + ')</font></span><br />';
  if bgCounCacher > 7 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least one find in 8 distinct countries <font color="blue">(' + IntToStr(bgCounCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least one find in 8 distinct countries <font color="red">(' + IntToStr(bgCounCacher) + ')</font></span><br />';
  if bgMatrCacher = 81 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 81 D/T combinations completed (100%) <font color="blue">(' + IntToStr(bgMatrCacher) + ')</font></span><br />'
  else
	ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 81 D/T combinations completed (100%) <font color="red">(' + IntToStr(bgMatrCacher) + ')</font></span><br />';
  if bgFiveCacher > 0 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> one 5/5 D/T rated cache <font color="blue">(' + IntToStr(bgFiveCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> one 5/5 D/T rated cache <font color="red">(' + IntToStr(bgFiveCacher) + ')</font></span><br />';
  if StrToInt(CountDaily) > 49 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 50 consecutive days with a cache find <font color="blue">(' + CountDaily + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 50 consecutive days with a cache find <font color="red">(' + CountDaily + ')</font></span><br />';
  if bgTwenCacher > 49 then
    ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 50 caches found on a single day <font color="blue">(' + IntToStr(bgTwenCacher) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 50 caches found on a single day <font color="red">(' + IntToStr(bgTwenCacher) + ')</font></span><br />';
  if bgElevCacher > 999 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> at least one cache found above 1000m elevation <font color="blue">(' + IntToStr(bgElevCacher) + 'm)</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> at least one cache found above 1000m elevation <font color="red">(' + IntToStr(bgElevCacher) + 'm)</font></span><br />';
  if CountOwnerType > 4 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 5 distinct types of caches hidden (any types incl. events) <font color="blue">(' + IntToStr(CountOwnerType) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 5 distinct types of caches hidden (any types incl. events) <font color="red">(' + IntToStr(CountOwnerType) + ')</font></span><br />';
  if gold > 2 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> 3 gold badges for container size <font color="blue">(' + IntToStr(gold) + ')</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> 3 gold badges for container size <font color="red">(' + IntToStr(gold) + ')</font></span><br />';
  if StrToFl(CountDailyDist) > 500 then
	ihtml := ihtml + spc +'<img src="' + yes + '" /><span style="font-size: small"> Maximum distance in a day of 500km or more <font color="blue">(' + CountDailyDist + 'km)</font></span><br />'
  else
    ihtml := ihtml + spc +'<img src="' + no + '" /><span style="font-size: small"> Maximum distance in a day of 500km or more <font color="red">(' + CountDailyDist + 'km)</font></span><br />';	
  ihtml := ihtml + '</td></tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;  
  //
  infhtml := infhtml + ihtml;
  //
  Inc(cnt);
  GeoBusyProgress(cnt, max_bg); 
  
end;
//******************************************************************************
//								B E L T S   I I
//******************************************************************************
procedure BeltsII();
var
 Sum: extended;
 belt, base, basename, imgname, ihtml, ccolor, mx: String;
begin
	//http://gc.zlej.net/b/Belt_Green.png
	//Test
	if Trim(BGSForm_cbLang.Items[BGSForm_cbLang.ItemIndex]) = 'CZ' then
		UseLanguage('CS')
	else
		UseLanguage('EN');
				
	
	belt := '0'; mx := '30';
    basename := 'belt';
	Sum := CachePoints + HostPoints + MatrixPoints + SumCountryPoints + DailyPoints + BusyPoints +
		   FPPoints + FDistPoints + HDistPoints + HSizePoints + FTFPoints + F55Points + GemPoints +
		   VeteranPoints + CalendarPoints + TBPoints + PhotoPoints;
	
	if Sum >= 30 then begin belt := '1'; mx := '40'; end;
	if Sum >= 40 then begin belt := '2'; mx := '50'; end;
	if Sum >= 50 then begin belt := '3'; mx := '60'; end;
	if Sum >= 60 then begin belt := '4'; mx := '70'; end;
	if Sum >= 70 then begin belt := '5'; mx := '80'; end;
	if Sum >= 80 then begin belt := '6'; mx := '90'; end;
	if Sum >= 90 then begin belt := '7'; mx := '100'; end;
	if Sum >= 100 then begin belt := '8'; mx := '110'; end;
	if Sum >= 110 then begin belt := '9'; mx := '120'; end;
	if Sum >= 120 then begin belt := '10'; mx := '130'; end;
	if Sum >= 130 then begin belt := '11'; mx := '140'; end;
	if Sum >= 140 then begin belt := '12'; mx := '150'; end;
	if Sum >= 150 then begin belt := '13'; mx := '160'; end;
	if Sum >= 160 then begin belt := '14'; mx := '170'; end;
	if Sum >= 170 then begin belt := '15'; mx := '180'; end;
	if Sum >= 180 then begin belt := '16'; mx := '190'; end;
	if Sum >= 190 then begin belt := '17'; mx := '200'; end;
	if Sum >= 200 then begin belt := '18'; mx := '210'; end;
	if Sum >= 210 then begin belt := '19'; mx := '220'; end;
	if Sum >= 220 then begin belt := '20'; mx := '232'; end;
	if Sum >= 232 then begin belt := '21'; mx := '244'; end;
	if Sum >= 244 then begin belt := '22'; mx := '256'; end;
	if Sum >= 256 then begin belt := '23'; mx := '268'; end;
	if Sum >= 268 then begin belt := '24'; mx := '280'; end;
	if Sum >= 280 then begin belt := '25'; mx := '292'; end;
	if Sum >= 292 then begin belt := '26'; mx := '304'; end;
	if Sum >= 304 then begin belt := '27'; mx := '316'; end;
	if Sum >= 316 then begin belt := '28'; mx := '328'; end;
	if Sum >= 328 then begin belt := '29'; mx := '340'; end;
	if Sum >= 340 then begin belt := '30'; mx := '352'; end;
	if Sum >= 352 then begin belt := '31'; mx := '364'; end;
	if Sum >= 364 then begin belt := '32'; mx := '376'; end;
	if Sum >= 376 then begin belt := '33'; mx := '388'; end;
	if Sum >= 388 then begin belt := '34'; mx := '400'; end;
	if Sum >= 400 then begin belt := '35'; mx := '+++'; end;
	//
	base := Trim(BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]) + 'b2/';
	imgname := base + basename + belt;
	if BGSForm_chbBeltShow.checked then
		htmlBelt := '<img src="' + imgname + '.png" width="' + Trim(IntToStr(Round((175 * StrToInt(BGSForm_edBBSize.Text))/100.0))) + 
				    '" title="' + _('Score:') + ' ' + FlToStr(round(Sum*100)/100.0) + ' ' + _('pt.') + ' (' + _('next:') + ' ' + mx +
					' ' + _('pt.') + ')" />' + CRLF
	else
		htmlBelt := '';
	//
	ihtml := ihtml + '<div class="BGII_BeltII" style="display:block; margin: 0 auto;">' + CRLF;
    ihtml := ihtml + '<table border="1" style="background-color:#' + TableListHeaderBkg + ';" bordercolor="#' + TableEmptyBkgOdd + '" width="' + iWidth + '" cellpadding="3" cellspacing="0">' + CRLF;
	ihtml := ihtml + '<tr><td>';
	//
	ihtml := ihtml + '<br /><br />' + CRLF + '<div class="BGII_BeltII_text" align="center" style="font-family:verdana; font-size:40px;"><b>' + _('Belt evaluation') + '</b></div>' + CRLF + '<br /><br />' + CRLF;
	//Cache
	ihtml := ihtml + '<ul>' + CRLF + '<li>' + _('1 point per 100 caches found:') + ' <font color="blue">' + IntToStr(bgGGeocacher) + ' ' + _('caches') + ' = ' + IntToStr(CachePoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//Host
	if HostPoints = 30 then ccolor := '<font color="green">' + IntToStr(bgHostCacher) + ' ' + _('is max') + ' = ' 
					   else ccolor := '<font color="blue">' + IntToStr(bgHostCacher) + ' ' + _('hosted') + ' = ';
	ihtml := ihtml + '<li>' + _('2 points per event hosted <b>(max.30 pt.)</b>:') + ' ' + ccolor + IntToStr(HostPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//Matrix
	if bgMatrCacher > 40 then ccolor := '<font color="blue">' + IntToStr(bgMatrCacher) + ' ' + _('is more then 40 pt.') + ' = '
						 else ccolor := '<font color="red">' + IntToStr(bgMatrCacher) + ' ' + _('is less than 41 pt.') + ' = ';
	ihtml := ihtml + '<li>' + _('0.5 points per D/T combination found in excess of 40 combinations:') + ' ' + ccolor + FlToStr(MatrixPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	if bgMatrCacher = 81 then begin 
	  ccolor := '<font color="green">' + IntToStr(bgMatrCacher) + ' ' + _('is complete Matrix then') + ' ';
	  ihtml := ihtml + '<li>' + _('+10 points for completing the D/T matrix:') + ' ' + ccolor + FlToStr(MatrixPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	end;
	//Country/State
	if SumCountryPoints = 20 then ccolor := '<br /><font color="green">' + IntToStr(StatePoints) + '/' + IntToStr(CountryPoints) + ' ' + ('is complete States/Countries then') + ' '
						     else ccolor := '<br /><font color="red">' + IntToStr(StatePoints) + '/' + IntToStr(CountryPoints) + ' ' + _('isn''t complete States/Countries then') + ' ';
	ihtml := ihtml + '<li>' + _('20 points for either finding caches in 15 USA distinct states <b>or</b> 5 distinct countries:') + ' ' + ccolor + IntToStr(SumCountryPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//za kadch 50 ke v den kdy m lovk nejvce nlez
	if BusyPoints = 40 then ccolor := '<font color="green">' + IntToStr(bgTwenCacher) + ' ' + _('is max') + ' = ' 
					   else begin 
							if bgTwenCacher < 50 then ccolor := '<font color="red">' + IntToStr(bgTwenCacher) + ' ' + _('< 50 then') + ' '
												 else ccolor := '<font color="blue">' + IntToStr(bgTwenCacher) + ' ' + _('caches') + '  = ';
					   end;
	ihtml := ihtml + '<li>' + _('10 points per 50 caches found on day with most finds <b>(max.40 pt.)</b>:') + ' ' + ccolor + IntToStr(BusyPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//kalendn dny
	if DailyPoints = 0 then ccolor := '<font color="red">' + IntToStr(bgConsCacher) + ' ' + _('isn''t 7 days') + ' = ' 
					   else begin
							if bgConsCacher >= 366 then ccolor := '<br /><font color="green">' + IntToStr(bgConsCacher) + ' ' + _('days + 10 points bonus') + ' = '
												   else ccolor := '<br /><font color="blue">' + IntToStr(bgConsCacher) + ' ' + _('days') + ' = ';		
					   end;
	ihtml := ihtml + '<li>' + _('0.5 points per 7 consecutive days with finds in largest streak. 10 point bonus at 366 days:') + ' ' + ccolor + FlToStr(DailyPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//FP
	ihtml := ihtml + '<li>' + _('0.1 points per favorite point on owned caches:') + ' <font color="blue">' + IntToStr(bgFPCacher) + ' FP = ' + FlToStr(FPPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//max found types in one day
	ihtml := ihtml + '<li>' + _('2 points per distinct cache type on day with most distinct types found:') + ' <font color="blue">' + IntToStr(bgUniqueTypesInDay) + ' ' + _('cache type') + ' = ' + IntToStr(FDistPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//My own type
	ihtml := ihtml + '<li>' + _('2 points per distinct cache type hidden:') + ' <font color="blue">' + IntToStr(High(CacheOwnType)+1) + ' ' + _('cache type') + ' = ' + IntToStr(HDistPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//My own size
	ihtml := ihtml + '<li>' + _('2 points per disctinct cache size hidden:') + ' <font color="blue">' + IntToStr(High(CacheOwnBSize)+1) + ' ' + _('cache size') + ' = ' + IntToStr(HSizePoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//FTF
	if FTFPoints = 30 then ccolor := '<font color="green">' + IntToStr(bgFTFCacher) + ' ' + _('is max') + ' = ' 
					   else ccolor := '<font color="blue">' + IntToStr(bgFTFCacher) + ' FTF = ';
	ihtml := ihtml + '<li>' + _('0.5 points per FTF <b>(max.30 pt.)</b>:') + ' ' + ccolor + FlToStr(FTFPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//5/5
	if F55Points = 5 then ccolor := '<font color="green">' + IntToStr(bgFiveCacher) + ' ' + _('is max') + ' = ' 
					 else ccolor := '<font color="blue">' + IntToStr(bgFiveCacher) + ' [5/5] ' + _('cache') + ' = ';
	ihtml := ihtml + '<li>' + _('1 point per 5/5 Difficulty/Terrain cache found <b>(max.5 pt.)</b>:') + ' ' + ccolor + IntToStr(F55Points) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//gemstone
	ihtml := ihtml + '<li>' + _('1 point per gemstone badge (excluding country badges):') + ' <font color="blue">' + IntToStr(GemPoints) + ' ' + _('gemstone') + ' = ' + IntToStr(GemPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//veteran
	ihtml := ihtml + '<li>' + _('2 points for every year since your first cache find:') + ' <font color="blue">' + IntToStr(bgVeteCacher) + ' ' + _('year caching') + ' = ' + IntToStr(VeteranPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//calendar days > 100
	if bgCaleCacher < 100 then ccolor := '<font color="red">' + IntToStr(bgCaleCacher) + ' ' + _('< 100 then') + ' '
						  else ccolor := '<font color="blue">' + IntToStr(bgCaleCacher) + ' ' + _('day') + ' = ';
	ihtml := ihtml + '<li>' + _('0.08 points per calendar day cached on. No points awarded if distinct days is less than 100. The year is negligible.:') + ' ' + ccolor + FlToStr(CalendarPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//TB/GC move/discover
	if TBPoints = 25 then ccolor := '<font color="green">' + IntToStr(bgTravCacher + bgCoinCacher) + ' ' + _('is max') + ' = ' 
					 else ccolor := '<font color="blue">' + IntToStr(bgTravCacher + bgCoinCacher) + ' TB/GC = ';
	ihtml := ihtml + '<li>' + _('0.05 points per trackable moved/discovered <b>(max.25 pt.)</b>:') + ' ' + ccolor + FlToStr(TBPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//Photo
	if PhotoPoints = 25 then ccolor := '<font color="green">' + IntToStr(bgPhotoCacher) + ' ' + _('is max') + ' = ' 
					    else ccolor := '<font color="blue">' + IntToStr(bgPhotoCacher) + ' ' + _('photo') + ' = ';
	ihtml := ihtml + '<li>' + _('0.1 points per photo uploaded to found logs <b>(max.25 pt.)</b>:') + ' ' + ccolor + FlToStr(PhotoPoints) + ' ' + _('pt.') + '</font></li>' + CRLF;
	//
	ihtml := ihtml + '</ul>' + CRLF;
	ihtml := ihtml + '<br />' + CRLF + '<div class="BGII_BeltII_score" align="center" style="font-family:verdana;color:green;font-size:40px;"><b>' + _('Score:') + ' ' + FlToStr(round(Sum*100)/100.0) + ' ' + _('pt.') + '</b></div>' + CRLF + '<br /><br />';
	ihtml := ihtml + '</tr></td>';
	ihtml := ihtml + '<tr><td>' + CRLF + '<div class="BGII_BeltII_table" align="center">' + CRLF + '<table>' + CRLF;
	ihtml := ihtml + '<tr><td><br></td><td><br></td><td>' + CRLF + '<div align="center"><br />';
	ihtml := ihtml + '<span><img src="' + base + 'belt0.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><br></td><td><br></td></tr>' + CRLF + '<tr><td><br></td><td><br></td><td><div align="center">0-30</div>';
	ihtml := ihtml + '</td><td><br></td><td><br></td></tr>' + CRLF + '<tr>';
    ihtml := ihtml + '<td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt1.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt2.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt3.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt4.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt5.png" width="100"></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + CRLF + '<div align="center">30-40</div></td>';
    ihtml := ihtml + '<td><div align="center">40-50</div></td>';
    ihtml := ihtml + '<td><div align="center">50-60</div></td>';
    ihtml := ihtml + '<td><div align="center">60-70</div></td>';
    ihtml := ihtml + '<td><div align="center">70-80</div></td></tr>';
	ihtml := ihtml + '<tr><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt6.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt7.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt8.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt9.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt10.png" width="100"></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><div align="center">80-90</div></td>';
    ihtml := ihtml + '<td><div align="center">90-100</div></td>';
    ihtml := ihtml + '<td><div align="center">100-110</div></td>';
    ihtml := ihtml + '<td><div align="center">110-120</div></td>';
    ihtml := ihtml + '<td><div align="center">120-130</div></td></tr>';
	ihtml := ihtml + '<tr><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt11.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt12.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt13.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt14.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt15.png" width="100"></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><div align="center">130-140</div></td>';
    ihtml := ihtml + '<td><div align="center">140-150</div></td>';
    ihtml := ihtml + '<td><div align="center">150-160</div></td>';
    ihtml := ihtml + '<td><div align="center">160-170</div></td>';
    ihtml := ihtml + '<td><div align="center">170-180</div></td></tr>';
	ihtml := ihtml + '<tr><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt16.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt17.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt18.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt19.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt20.png" width="100"></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><div align="center">180-190</div></td>';
    ihtml := ihtml + '<td><div align="center">190-200</div></td>';
    ihtml := ihtml + '<td><div align="center">200-210</div></td>';
    ihtml := ihtml + '<td><div align="center">210-220</div></td>';
    ihtml := ihtml + '<td><div align="center">220-232</div></td></tr>';
	ihtml := ihtml + '<tr><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt21.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt22.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt23.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt24.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt25.png" width="100"></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><div align="center">232-244</div></td>';
    ihtml := ihtml + '<td><div align="center">244-256</div></td>';
    ihtml := ihtml + '<td><div align="center">256-268</div></td>';
    ihtml := ihtml + '<td><div align="center">268-280</div></td>';
    ihtml := ihtml + '<td><div align="center">280-292</div></td></tr>';	
	ihtml := ihtml + '<tr><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt26.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt27.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt28.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt29.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt30.png" width="100"></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><div align="center">292-304</div></td>';
    ihtml := ihtml + '<td><div align="center">304-316</div></td>';
    ihtml := ihtml + '<td><div align="center">316-328</div></td>';
    ihtml := ihtml + '<td><div align="center">328-340</div></td>';
    ihtml := ihtml + '<td><div align="center">340-352</div></td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>';
	ihtml := ihtml + '<br>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt31.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td>';
	ihtml := ihtml + '<br>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt32.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td>';
	ihtml := ihtml + '<br>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><br></td>';
    ihtml := ihtml + '<td><div align="center">352-364</div></td>';
    ihtml := ihtml + '<td><br></td>';
    ihtml := ihtml + '<td><div align="center">364-376</div></td>';
    ihtml := ihtml + '<td><br></td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>';
	ihtml := ihtml + '<br>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt33.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt34.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td><div align="center">';
	ihtml := ihtml + '<span><img src="' + base + 'belt35.png" width="100"></span></div>';
	ihtml := ihtml + '</td><td>';
	ihtml := ihtml + '<br>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><br></td>';
    ihtml := ihtml + '<td><div align="center">376-388</div></td>';
    ihtml := ihtml + '<td><div align="center">388-400</div></td>';
    ihtml := ihtml + '<td><div align="center">400+</div></td>';
    ihtml := ihtml + '<td><br></td></tr>' + CRLF;
	ihtml := ihtml + '</table>' + CRLF + '</div></td></tr>' + CRLF;
	ihtml := ihtml + '</table>' + CRLF + '</div>';
	//
	infhtml := infhtml + ihtml;
	//
	UseLanguage('');
	//
	Inc(cnt);
	GeoBusyProgress(cnt, max_bg); 
end;